/* TrashStore.c generated by valac 0.56.8, the Vala compiler
 * generated from TrashStore.vala, do not modify */

/*
 * This file is part of UbuntuBudgie
 *
 * Copyright 2019 Evan Maddock, 2021 Ubuntu Budgie Developers
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "trashapplet.h"
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define _trash_applet_trash_store_unref0(var) ((var == NULL) ? NULL : (var = (trash_applet_trash_store_unref (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
typedef struct _TrashAppletParamSpecTrashStore TrashAppletParamSpecTrashStore;
enum  {
	TRASH_APPLET_TRASH_STORE_TRASH_ADDED_SIGNAL,
	TRASH_APPLET_TRASH_STORE_TRASH_REMOVED_SIGNAL,
	TRASH_APPLET_TRASH_STORE_NUM_SIGNALS
};
static guint trash_applet_trash_store_signals[TRASH_APPLET_TRASH_STORE_NUM_SIGNALS] = {0};

struct _TrashAppletTrashStorePrivate {
	TrashAppletApplet* applet;
	GFile* trash_dir;
	GFile* info_dir;
	gchar* drive_name;
	gchar* drive_path;
	GIcon* drive_icon;
	GFileMonitor* trash_monitor;
	gint _trash_count;
};

struct _Block4Data {
	int _ref_count_;
	TrashAppletTrashStore* self;
	GFile* file;
	GFile* info_file;
	gchar* file_name;
};

struct _TrashAppletParamSpecTrashStore {
	GParamSpec parent_instance;
};

static gint TrashAppletTrashStore_private_offset;
static gpointer trash_applet_trash_store_parent_class = NULL;
static GType trash_applet_trash_store_type_id = 0;

static void trash_applet_trash_store_handle_trash_changed (TrashAppletTrashStore* self,
                                                    GFile* file,
                                                    GFile* other_file,
                                                    GFileMonitorEvent event);
static void _trash_applet_trash_store_handle_trash_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                                            GFile* file,
                                                                            GFile* other_file,
                                                                            GFileMonitorEvent event_type,
                                                                            gpointer self);
static gchar* trash_applet_trash_store_get_path_from_trashinfo (TrashAppletTrashStore* self,
                                                         const gchar* file_name);
static GDateTime* trash_applet_trash_store_get_deletion_date (TrashAppletTrashStore* self,
                                                       const gchar* file_name);
static void trash_applet_trash_store_set_trash_count (TrashAppletTrashStore* self,
                                               gint value);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gint ___lambda5_ (Block4Data* _data4_);
static void trash_applet_trash_store_delete_directory (TrashAppletTrashStore* self,
                                                GFile* dir,
                                                GError** error);
static gpointer ____lambda5__gthread_func (gpointer self);
static void g_cclosure_user_marshal_VOID__STRING_STRING_OBJECT_BOXED_BOOLEAN (GClosure * closure,
                                                                       GValue * return_value,
                                                                       guint n_param_values,
                                                                       const GValue * param_values,
                                                                       gpointer invocation_hint,
                                                                       gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_BOOLEAN (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void trash_applet_trash_store_finalize (TrashAppletTrashStore * obj);

static inline gpointer
trash_applet_trash_store_get_instance_private (TrashAppletTrashStore* self)
{
	return G_STRUCT_MEMBER_P (self, TrashAppletTrashStore_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 47 "../budgie-trash/trash/src/TrashStore.vala"
	return self ? g_object_ref (self) : NULL;
#line 123 "TrashStore.c"
}

static void
_trash_applet_trash_store_handle_trash_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                                       GFile* file,
                                                                       GFile* other_file,
                                                                       GFileMonitorEvent event_type,
                                                                       gpointer self)
{
#line 61 "../budgie-trash/trash/src/TrashStore.vala"
	trash_applet_trash_store_handle_trash_changed ((TrashAppletTrashStore*) self, file, other_file, event_type);
#line 135 "TrashStore.c"
}

TrashAppletTrashStore*
trash_applet_trash_store_construct (GType object_type,
                                    TrashAppletApplet* applet,
                                    GFile* trash_dir,
                                    GFile* info_dir,
                                    const gchar* drive_name,
                                    const gchar* drive_path,
                                    GIcon* drive_icon)
{
	TrashAppletTrashStore* self = NULL;
	TrashAppletApplet* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GIcon* _tmp5_;
	GFileMonitor* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 46 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_val_if_fail (applet != NULL, NULL);
#line 46 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_val_if_fail (trash_dir != NULL, NULL);
#line 46 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_val_if_fail (info_dir != NULL, NULL);
#line 46 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_val_if_fail (drive_name != NULL, NULL);
#line 46 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_val_if_fail (drive_icon != NULL, NULL);
#line 46 "../budgie-trash/trash/src/TrashStore.vala"
	self = (TrashAppletTrashStore*) g_type_create_instance (object_type);
#line 47 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp0_ = _g_object_ref0 (applet);
#line 47 "../budgie-trash/trash/src/TrashStore.vala"
	_g_object_unref0 (self->priv->applet);
#line 47 "../budgie-trash/trash/src/TrashStore.vala"
	self->priv->applet = _tmp0_;
#line 48 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp1_ = _g_object_ref0 (trash_dir);
#line 48 "../budgie-trash/trash/src/TrashStore.vala"
	_g_object_unref0 (self->priv->trash_dir);
#line 48 "../budgie-trash/trash/src/TrashStore.vala"
	self->priv->trash_dir = _tmp1_;
#line 49 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp2_ = _g_object_ref0 (info_dir);
#line 49 "../budgie-trash/trash/src/TrashStore.vala"
	_g_object_unref0 (self->priv->info_dir);
#line 49 "../budgie-trash/trash/src/TrashStore.vala"
	self->priv->info_dir = _tmp2_;
#line 50 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp3_ = g_strdup (drive_name);
#line 50 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (self->priv->drive_name);
#line 50 "../budgie-trash/trash/src/TrashStore.vala"
	self->priv->drive_name = _tmp3_;
#line 51 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp4_ = g_strdup (drive_path);
#line 51 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (self->priv->drive_path);
#line 51 "../budgie-trash/trash/src/TrashStore.vala"
	self->priv->drive_path = _tmp4_;
#line 52 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp5_ = _g_object_ref0 (drive_icon);
#line 52 "../budgie-trash/trash/src/TrashStore.vala"
	_g_object_unref0 (self->priv->drive_icon);
#line 52 "../budgie-trash/trash/src/TrashStore.vala"
	self->priv->drive_icon = _tmp5_;
#line 204 "TrashStore.c"
	{
		GFileMonitor* _tmp6_ = NULL;
		GFileMonitor* _tmp7_;
		GFileMonitor* _tmp8_;
#line 55 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp7_ = g_file_monitor_directory (trash_dir, G_FILE_MONITOR_WATCH_MOVES, NULL, &_inner_error0_);
#line 55 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp6_ = _tmp7_;
#line 55 "../budgie-trash/trash/src/TrashStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 215 "TrashStore.c"
			goto __catch0_g_error;
		}
#line 55 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp8_ = _tmp6_;
#line 55 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp6_ = NULL;
#line 55 "../budgie-trash/trash/src/TrashStore.vala"
		_g_object_unref0 (self->priv->trash_monitor);
#line 55 "../budgie-trash/trash/src/TrashStore.vala"
		self->priv->trash_monitor = _tmp8_;
#line 54 "../budgie-trash/trash/src/TrashStore.vala"
		_g_object_unref0 (_tmp6_);
#line 228 "TrashStore.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 54 "../budgie-trash/trash/src/TrashStore.vala"
		e = _inner_error0_;
#line 54 "../budgie-trash/trash/src/TrashStore.vala"
		_inner_error0_ = NULL;
#line 57 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp9_ = e;
#line 57 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp10_ = _tmp9_->message;
#line 57 "../budgie-trash/trash/src/TrashStore.vala"
		g_warning ("TrashStore.vala:57: Unable to create a TrashStore: %s", _tmp10_);
#line 58 "../budgie-trash/trash/src/TrashStore.vala"
		_g_error_free0 (e);
#line 58 "../budgie-trash/trash/src/TrashStore.vala"
		return self;
#line 250 "TrashStore.c"
	}
	__finally0:
#line 54 "../budgie-trash/trash/src/TrashStore.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 54 "../budgie-trash/trash/src/TrashStore.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 54 "../budgie-trash/trash/src/TrashStore.vala"
		g_clear_error (&_inner_error0_);
#line 54 "../budgie-trash/trash/src/TrashStore.vala"
		return NULL;
#line 261 "TrashStore.c"
	}
#line 61 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp11_ = self->priv->trash_monitor;
#line 61 "../budgie-trash/trash/src/TrashStore.vala"
	g_signal_connect (_tmp11_, "changed", (GCallback) _trash_applet_trash_store_handle_trash_changed_g_file_monitor_changed, self);
#line 46 "../budgie-trash/trash/src/TrashStore.vala"
	return self;
#line 269 "TrashStore.c"
}

TrashAppletTrashStore*
trash_applet_trash_store_new (TrashAppletApplet* applet,
                              GFile* trash_dir,
                              GFile* info_dir,
                              const gchar* drive_name,
                              const gchar* drive_path,
                              GIcon* drive_icon)
{
#line 46 "../budgie-trash/trash/src/TrashStore.vala"
	return trash_applet_trash_store_construct (TRASH_APPLET_TYPE_TRASH_STORE, applet, trash_dir, info_dir, drive_name, drive_path, drive_icon);
#line 282 "TrashStore.c"
}

/**
         * Gets all of the current items in this store's trash bin.
         *
         * A `trash_added` signal is emitted for each found trash item so
         * the UI can add each one accordingly.
         */
void
trash_applet_trash_store_get_current_trash_items (TrashAppletTrashStore* self)
{
	TrashAppletApplet* _tmp30_;
	GError* _inner_error0_ = NULL;
#line 70 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_if_fail (self != NULL);
#line 298 "TrashStore.c"
	{
		gchar* attributes = NULL;
		gchar* _tmp0_;
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp1_;
		const gchar* _tmp2_;
		GFileEnumerator* _tmp3_;
		GFileInfo* info = NULL;
#line 72 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp0_ = g_strdup (G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_ICON "," G_FILE_ATTRIBUTE_STANDARD_TYPE);
#line 72 "../budgie-trash/trash/src/TrashStore.vala"
		attributes = _tmp0_;
#line 75 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp1_ = self->priv->trash_dir;
#line 75 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp2_ = attributes;
#line 75 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp3_ = g_file_enumerate_children (_tmp1_, _tmp2_, 0, NULL, &_inner_error0_);
#line 75 "../budgie-trash/trash/src/TrashStore.vala"
		enumerator = _tmp3_;
#line 75 "../budgie-trash/trash/src/TrashStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 75 "../budgie-trash/trash/src/TrashStore.vala"
			_g_free0 (attributes);
#line 323 "TrashStore.c"
			goto __catch0_g_error;
		}
#line 78 "../budgie-trash/trash/src/TrashStore.vala"
		while (TRUE) {
#line 328 "TrashStore.c"
			GFileInfo* _tmp4_ = NULL;
			GFileEnumerator* _tmp5_;
			GFileInfo* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			gchar* path = NULL;
			GFileInfo* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			const gchar* _tmp12_;
			gboolean is_directory = FALSE;
			GFileInfo* _tmp15_;
			GDateTime* deletion_time = NULL;
			GFileInfo* _tmp16_;
			const gchar* _tmp17_;
			GDateTime* _tmp18_;
			gint _tmp19_;
			GFileInfo* _tmp20_;
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			GFileInfo* _tmp25_;
			GIcon* _tmp26_;
			GDateTime* _tmp27_;
#line 78 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp5_ = enumerator;
#line 78 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp6_ = g_file_enumerator_next_file (_tmp5_, NULL, &_inner_error0_);
#line 78 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp4_ = _tmp6_;
#line 78 "../budgie-trash/trash/src/TrashStore.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 78 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (info);
#line 78 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (enumerator);
#line 78 "../budgie-trash/trash/src/TrashStore.vala"
				_g_free0 (attributes);
#line 368 "TrashStore.c"
				goto __catch0_g_error;
			}
#line 78 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp7_ = _tmp4_;
#line 78 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp4_ = NULL;
#line 78 "../budgie-trash/trash/src/TrashStore.vala"
			_g_object_unref0 (info);
#line 78 "../budgie-trash/trash/src/TrashStore.vala"
			info = _tmp7_;
#line 78 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp8_ = info;
#line 78 "../budgie-trash/trash/src/TrashStore.vala"
			if (!(_tmp8_ != NULL)) {
#line 78 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (_tmp4_);
#line 78 "../budgie-trash/trash/src/TrashStore.vala"
				break;
#line 387 "TrashStore.c"
			}
#line 79 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp9_ = info;
#line 79 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp10_ = g_file_info_get_name (_tmp9_);
#line 79 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp11_ = trash_applet_trash_store_get_path_from_trashinfo (self, _tmp10_);
#line 79 "../budgie-trash/trash/src/TrashStore.vala"
			path = _tmp11_;
#line 81 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp12_ = path;
#line 81 "../budgie-trash/trash/src/TrashStore.vala"
			if (_tmp12_ == NULL) {
#line 401 "TrashStore.c"
				GFileInfo* _tmp13_;
				const gchar* _tmp14_;
#line 82 "../budgie-trash/trash/src/TrashStore.vala"
				_tmp13_ = info;
#line 82 "../budgie-trash/trash/src/TrashStore.vala"
				_tmp14_ = g_file_info_get_name (_tmp13_);
#line 82 "../budgie-trash/trash/src/TrashStore.vala"
				g_warning ("TrashStore.vala:82: Unable to get the path for %s", _tmp14_);
#line 83 "../budgie-trash/trash/src/TrashStore.vala"
				_g_free0 (path);
#line 83 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (_tmp4_);
#line 83 "../budgie-trash/trash/src/TrashStore.vala"
				continue;
#line 416 "TrashStore.c"
			}
#line 86 "../budgie-trash/trash/src/TrashStore.vala"
			is_directory = FALSE;
#line 87 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp15_ = info;
#line 87 "../budgie-trash/trash/src/TrashStore.vala"
			if (g_file_info_get_file_type (_tmp15_) == G_FILE_TYPE_DIRECTORY) {
#line 88 "../budgie-trash/trash/src/TrashStore.vala"
				is_directory = TRUE;
#line 426 "TrashStore.c"
			}
#line 91 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp16_ = info;
#line 91 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp17_ = g_file_info_get_name (_tmp16_);
#line 91 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp18_ = trash_applet_trash_store_get_deletion_date (self, _tmp17_);
#line 91 "../budgie-trash/trash/src/TrashStore.vala"
			deletion_time = _tmp18_;
#line 93 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp19_ = self->priv->_trash_count;
#line 93 "../budgie-trash/trash/src/TrashStore.vala"
			trash_applet_trash_store_set_trash_count (self, _tmp19_ + 1);
#line 94 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp20_ = info;
#line 94 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp21_ = g_file_info_get_name (_tmp20_);
#line 94 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp22_ = path;
#line 94 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp23_ = g_uri_unescape_string (_tmp22_, NULL);
#line 94 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp24_ = _tmp23_;
#line 94 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp25_ = info;
#line 94 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp26_ = g_file_info_get_icon (_tmp25_);
#line 94 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp27_ = deletion_time;
#line 94 "../budgie-trash/trash/src/TrashStore.vala"
			g_signal_emit (self, trash_applet_trash_store_signals[TRASH_APPLET_TRASH_STORE_TRASH_ADDED_SIGNAL], 0, _tmp21_, _tmp24_, _tmp26_, _tmp27_, is_directory);
#line 94 "../budgie-trash/trash/src/TrashStore.vala"
			_g_free0 (_tmp24_);
#line 78 "../budgie-trash/trash/src/TrashStore.vala"
			_g_date_time_unref0 (deletion_time);
#line 78 "../budgie-trash/trash/src/TrashStore.vala"
			_g_free0 (path);
#line 78 "../budgie-trash/trash/src/TrashStore.vala"
			_g_object_unref0 (_tmp4_);
#line 466 "TrashStore.c"
		}
#line 71 "../budgie-trash/trash/src/TrashStore.vala"
		_g_object_unref0 (info);
#line 71 "../budgie-trash/trash/src/TrashStore.vala"
		_g_object_unref0 (enumerator);
#line 71 "../budgie-trash/trash/src/TrashStore.vala"
		_g_free0 (attributes);
#line 474 "TrashStore.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp28_;
		const gchar* _tmp29_;
#line 71 "../budgie-trash/trash/src/TrashStore.vala"
		e = _inner_error0_;
#line 71 "../budgie-trash/trash/src/TrashStore.vala"
		_inner_error0_ = NULL;
#line 97 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp28_ = e;
#line 97 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp29_ = _tmp28_->message;
#line 97 "../budgie-trash/trash/src/TrashStore.vala"
		g_warning ("TrashStore.vala:97: Unable to create trash item: %s", _tmp29_);
#line 71 "../budgie-trash/trash/src/TrashStore.vala"
		_g_error_free0 (e);
#line 494 "TrashStore.c"
	}
	__finally0:
#line 71 "../budgie-trash/trash/src/TrashStore.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 71 "../budgie-trash/trash/src/TrashStore.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 71 "../budgie-trash/trash/src/TrashStore.vala"
		g_clear_error (&_inner_error0_);
#line 71 "../budgie-trash/trash/src/TrashStore.vala"
		return;
#line 505 "TrashStore.c"
	}
#line 99 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp30_ = self->priv->applet;
#line 99 "../budgie-trash/trash/src/TrashStore.vala"
	trash_applet_applet_update_trash_icon (_tmp30_);
#line 511 "TrashStore.c"
}

gchar*
trash_applet_trash_store_get_drive_name (TrashAppletTrashStore* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 102 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 103 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp0_ = self->priv->drive_name;
#line 103 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 103 "../budgie-trash/trash/src/TrashStore.vala"
	result = _tmp1_;
#line 103 "../budgie-trash/trash/src/TrashStore.vala"
	return result;
#line 530 "TrashStore.c"
}

GIcon*
trash_applet_trash_store_get_drive_icon (TrashAppletTrashStore* self)
{
	GIcon* _tmp0_;
	GIcon* _tmp1_;
	GIcon* result;
#line 106 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 107 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp0_ = self->priv->drive_icon;
#line 107 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 107 "../budgie-trash/trash/src/TrashStore.vala"
	result = _tmp1_;
#line 107 "../budgie-trash/trash/src/TrashStore.vala"
	return result;
#line 549 "TrashStore.c"
}

/**
         * Delete a file permanently from the trash.
         *
         * If the file is a directory, it will be recursively deleted.
         * This function spawns a new thread to do the deleting to
         * avoid locking the system up when removing large files.
         *
         * @param file_name The name of the file to delete
         */
static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 119 "../budgie-trash/trash/src/TrashStore.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 119 "../budgie-trash/trash/src/TrashStore.vala"
	return _data4_;
#line 568 "TrashStore.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 119 "../budgie-trash/trash/src/TrashStore.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 578 "TrashStore.c"
		TrashAppletTrashStore* self;
#line 119 "../budgie-trash/trash/src/TrashStore.vala"
		self = _data4_->self;
#line 119 "../budgie-trash/trash/src/TrashStore.vala"
		_g_object_unref0 (_data4_->info_file);
#line 119 "../budgie-trash/trash/src/TrashStore.vala"
		_g_object_unref0 (_data4_->file);
#line 119 "../budgie-trash/trash/src/TrashStore.vala"
		_g_free0 (_data4_->file_name);
#line 119 "../budgie-trash/trash/src/TrashStore.vala"
		_trash_applet_trash_store_unref0 (self);
#line 119 "../budgie-trash/trash/src/TrashStore.vala"
		g_slice_free (Block4Data, _data4_);
#line 592 "TrashStore.c"
	}
}

static gint
___lambda5_ (Block4Data* _data4_)
{
	TrashAppletTrashStore* self;
	GFileType type = 0;
	GError* _inner_error0_ = NULL;
	gint result;
#line 125 "../budgie-trash/trash/src/TrashStore.vala"
	self = _data4_->self;
#line 127 "../budgie-trash/trash/src/TrashStore.vala"
	type = g_file_query_file_type (_data4_->file, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 128 "../budgie-trash/trash/src/TrashStore.vala"
	if (type == G_FILE_TYPE_DIRECTORY) {
#line 609 "TrashStore.c"
		{
#line 131 "../budgie-trash/trash/src/TrashStore.vala"
			trash_applet_trash_store_delete_directory (self, _data4_->file, &_inner_error0_);
#line 131 "../budgie-trash/trash/src/TrashStore.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 615 "TrashStore.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp0_;
			const gchar* _tmp1_;
			TrashAppletApplet* _tmp2_;
			GError* _tmp3_;
			const gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
#line 130 "../budgie-trash/trash/src/TrashStore.vala"
			e = _inner_error0_;
#line 130 "../budgie-trash/trash/src/TrashStore.vala"
			_inner_error0_ = NULL;
#line 133 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp0_ = e;
#line 133 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp1_ = _tmp0_->message;
#line 133 "../budgie-trash/trash/src/TrashStore.vala"
			g_warning ("TrashStore.vala:133: Unable to delete directory '%s' in trash: %s", _data4_->file_name, _tmp1_);
#line 134 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp2_ = self->priv->applet;
#line 134 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp3_ = e;
#line 134 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp4_ = _tmp3_->message;
#line 134 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp5_ = g_strdup_printf (_ ("Unable to permanently delete '%s': %s"), _data4_->file_name, _tmp4_);
#line 134 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp6_ = _tmp5_;
#line 134 "../budgie-trash/trash/src/TrashStore.vala"
			trash_applet_applet_show_notification (_tmp2_, _ ("Empty Trash"), _tmp6_);
#line 134 "../budgie-trash/trash/src/TrashStore.vala"
			_g_free0 (_tmp6_);
#line 135 "../budgie-trash/trash/src/TrashStore.vala"
			result = -1;
#line 135 "../budgie-trash/trash/src/TrashStore.vala"
			_g_error_free0 (e);
#line 135 "../budgie-trash/trash/src/TrashStore.vala"
			return result;
#line 660 "TrashStore.c"
		}
		__finally0:
#line 130 "../budgie-trash/trash/src/TrashStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 665 "TrashStore.c"
			gint _tmp7_ = -1;
#line 130 "../budgie-trash/trash/src/TrashStore.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 130 "../budgie-trash/trash/src/TrashStore.vala"
			g_clear_error (&_inner_error0_);
#line 130 "../budgie-trash/trash/src/TrashStore.vala"
			return _tmp7_;
#line 673 "TrashStore.c"
		}
	}
	{
#line 141 "../budgie-trash/trash/src/TrashStore.vala"
		g_file_delete (_data4_->file, NULL, &_inner_error0_);
#line 141 "../budgie-trash/trash/src/TrashStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 681 "TrashStore.c"
			goto __catch1_g_error;
		}
#line 142 "../budgie-trash/trash/src/TrashStore.vala"
		g_file_delete (_data4_->info_file, NULL, &_inner_error0_);
#line 142 "../budgie-trash/trash/src/TrashStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 688 "TrashStore.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		TrashAppletApplet* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 140 "../budgie-trash/trash/src/TrashStore.vala"
		e = _inner_error0_;
#line 140 "../budgie-trash/trash/src/TrashStore.vala"
		_inner_error0_ = NULL;
#line 144 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp8_ = e;
#line 144 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp9_ = _tmp8_->message;
#line 144 "../budgie-trash/trash/src/TrashStore.vala"
		g_warning ("TrashStore.vala:144: Unable to delete directory '%s' in trash: %s", _data4_->file_name, _tmp9_);
#line 145 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp10_ = self->priv->applet;
#line 145 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp11_ = e;
#line 145 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp12_ = _tmp11_->message;
#line 145 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp13_ = g_strdup_printf (_ ("Unable to permanently delete '%s': %s"), _data4_->file_name, _tmp12_);
#line 145 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp14_ = _tmp13_;
#line 145 "../budgie-trash/trash/src/TrashStore.vala"
		trash_applet_applet_show_notification (_tmp10_, _ ("Empty Trash"), _tmp14_);
#line 145 "../budgie-trash/trash/src/TrashStore.vala"
		_g_free0 (_tmp14_);
#line 140 "../budgie-trash/trash/src/TrashStore.vala"
		_g_error_free0 (e);
#line 729 "TrashStore.c"
	}
	__finally1:
#line 140 "../budgie-trash/trash/src/TrashStore.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 734 "TrashStore.c"
		gint _tmp15_ = -1;
#line 140 "../budgie-trash/trash/src/TrashStore.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 140 "../budgie-trash/trash/src/TrashStore.vala"
		g_clear_error (&_inner_error0_);
#line 140 "../budgie-trash/trash/src/TrashStore.vala"
		return _tmp15_;
#line 742 "TrashStore.c"
	}
#line 148 "../budgie-trash/trash/src/TrashStore.vala"
	result = 0;
#line 148 "../budgie-trash/trash/src/TrashStore.vala"
	return result;
#line 748 "TrashStore.c"
}

static gpointer
____lambda5__gthread_func (gpointer self)
{
	gpointer result;
	result = (gpointer) ((gintptr) ___lambda5_ (self));
#line 125 "../budgie-trash/trash/src/TrashStore.vala"
	block4_data_unref (self);
#line 125 "../budgie-trash/trash/src/TrashStore.vala"
	return result;
#line 760 "TrashStore.c"
}

void
trash_applet_trash_store_delete_file (TrashAppletTrashStore* self,
                                      const gchar* file_name)
{
	Block4Data* _data4_;
	gchar* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GFile* _tmp19_;
	GFile* _tmp20_;
	GError* _inner_error0_ = NULL;
#line 119 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_if_fail (self != NULL);
#line 119 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_if_fail (file_name != NULL);
#line 119 "../budgie-trash/trash/src/TrashStore.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 119 "../budgie-trash/trash/src/TrashStore.vala"
	_data4_->_ref_count_ = 1;
#line 119 "../budgie-trash/trash/src/TrashStore.vala"
	_data4_->self = trash_applet_trash_store_ref (self);
#line 119 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp0_ = g_strdup (file_name);
#line 119 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_data4_->file_name);
#line 119 "../budgie-trash/trash/src/TrashStore.vala"
	_data4_->file_name = _tmp0_;
#line 120 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp1_ = self->priv->trash_dir;
#line 120 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 120 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp3_ = _tmp2_;
#line 120 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp4_ = g_strconcat (_tmp3_, "/", NULL);
#line 120 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp5_ = _tmp4_;
#line 120 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp6_ = g_strconcat (_tmp5_, _data4_->file_name, NULL);
#line 120 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp7_ = _tmp6_;
#line 120 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp8_ = g_file_new_for_path (_tmp7_);
#line 120 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp9_ = _tmp8_;
#line 120 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp7_);
#line 120 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp5_);
#line 120 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp3_);
#line 120 "../budgie-trash/trash/src/TrashStore.vala"
	_data4_->file = _tmp9_;
#line 121 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp10_ = self->priv->info_dir;
#line 121 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp11_ = g_file_get_path (_tmp10_);
#line 121 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp12_ = _tmp11_;
#line 121 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp13_ = g_strconcat (_tmp12_, "/", NULL);
#line 121 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp14_ = _tmp13_;
#line 121 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp15_ = g_strconcat (_tmp14_, _data4_->file_name, NULL);
#line 121 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp16_ = _tmp15_;
#line 121 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp17_ = g_strconcat (_tmp16_, ".trashinfo", NULL);
#line 121 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp18_ = _tmp17_;
#line 121 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp19_ = g_file_new_for_path (_tmp18_);
#line 121 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp20_ = _tmp19_;
#line 121 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp18_);
#line 121 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp16_);
#line 121 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp14_);
#line 121 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp12_);
#line 121 "../budgie-trash/trash/src/TrashStore.vala"
	_data4_->info_file = _tmp20_;
#line 864 "TrashStore.c"
	{
		GThread* _tmp21_;
		GThread* _tmp22_;
#line 125 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp21_ = g_thread_try_new ("trash-delete-thread", ____lambda5__gthread_func, block4_data_ref (_data4_), &_inner_error0_);
#line 125 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp22_ = _tmp21_;
#line 125 "../budgie-trash/trash/src/TrashStore.vala"
		_g_thread_unref0 (_tmp22_);
#line 125 "../budgie-trash/trash/src/TrashStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 876 "TrashStore.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp23_;
		const gchar* _tmp24_;
		TrashAppletApplet* _tmp25_;
		GError* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 124 "../budgie-trash/trash/src/TrashStore.vala"
		e = _inner_error0_;
#line 124 "../budgie-trash/trash/src/TrashStore.vala"
		_inner_error0_ = NULL;
#line 151 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp23_ = e;
#line 151 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp24_ = _tmp23_->message;
#line 151 "../budgie-trash/trash/src/TrashStore.vala"
		g_warning ("TrashStore.vala:151: Unable to delete '%s': %s", _data4_->file_name, _tmp24_);
#line 152 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp25_ = self->priv->applet;
#line 152 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp26_ = e;
#line 152 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp27_ = _tmp26_->message;
#line 152 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp28_ = g_strdup_printf (_ ("Unable to permanently delete '%s': %s"), _data4_->file_name, _tmp27_);
#line 152 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp29_ = _tmp28_;
#line 152 "../budgie-trash/trash/src/TrashStore.vala"
		trash_applet_applet_show_notification (_tmp25_, _ ("Empty Trash"), _tmp29_);
#line 152 "../budgie-trash/trash/src/TrashStore.vala"
		_g_free0 (_tmp29_);
#line 124 "../budgie-trash/trash/src/TrashStore.vala"
		_g_error_free0 (e);
#line 917 "TrashStore.c"
	}
	__finally0:
#line 124 "../budgie-trash/trash/src/TrashStore.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 124 "../budgie-trash/trash/src/TrashStore.vala"
		block4_data_unref (_data4_);
#line 124 "../budgie-trash/trash/src/TrashStore.vala"
		_data4_ = NULL;
#line 124 "../budgie-trash/trash/src/TrashStore.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 124 "../budgie-trash/trash/src/TrashStore.vala"
		g_clear_error (&_inner_error0_);
#line 124 "../budgie-trash/trash/src/TrashStore.vala"
		return;
#line 932 "TrashStore.c"
	}
#line 119 "../budgie-trash/trash/src/TrashStore.vala"
	block4_data_unref (_data4_);
#line 119 "../budgie-trash/trash/src/TrashStore.vala"
	_data4_ = NULL;
#line 938 "TrashStore.c"
}

/**
         * Recursively delete a directory.
         */
static void
trash_applet_trash_store_delete_directory (TrashAppletTrashStore* self,
                                           GFile* dir,
                                           GError** error)
{
	gchar* attributes = NULL;
	gchar* _tmp0_;
	GFileEnumerator* enumerator = NULL;
	const gchar* _tmp1_;
	GFileEnumerator* _tmp2_;
	GFileInfo* info = NULL;
	GError* _inner_error0_ = NULL;
#line 159 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_if_fail (self != NULL);
#line 159 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_if_fail (dir != NULL);
#line 160 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp0_ = g_strdup (G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE);
#line 160 "../budgie-trash/trash/src/TrashStore.vala"
	attributes = _tmp0_;
#line 161 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp1_ = attributes;
#line 161 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp2_ = g_file_enumerate_children (dir, _tmp1_, 0, NULL, &_inner_error0_);
#line 161 "../budgie-trash/trash/src/TrashStore.vala"
	enumerator = _tmp2_;
#line 161 "../budgie-trash/trash/src/TrashStore.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 161 "../budgie-trash/trash/src/TrashStore.vala"
		g_propagate_error (error, _inner_error0_);
#line 161 "../budgie-trash/trash/src/TrashStore.vala"
		_g_free0 (attributes);
#line 161 "../budgie-trash/trash/src/TrashStore.vala"
		return;
#line 978 "TrashStore.c"
	}
#line 164 "../budgie-trash/trash/src/TrashStore.vala"
	while (TRUE) {
#line 982 "TrashStore.c"
		GFileInfo* _tmp3_ = NULL;
		GFileEnumerator* _tmp4_;
		GFileInfo* _tmp5_;
		GFileInfo* _tmp6_;
		GFileInfo* _tmp7_;
		GFile* child = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GFileInfo* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
		GFileInfo* _tmp18_;
#line 164 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp4_ = enumerator;
#line 164 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp5_ = g_file_enumerator_next_file (_tmp4_, NULL, &_inner_error0_);
#line 164 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp3_ = _tmp5_;
#line 164 "../budgie-trash/trash/src/TrashStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 164 "../budgie-trash/trash/src/TrashStore.vala"
			g_propagate_error (error, _inner_error0_);
#line 164 "../budgie-trash/trash/src/TrashStore.vala"
			_g_object_unref0 (info);
#line 164 "../budgie-trash/trash/src/TrashStore.vala"
			_g_object_unref0 (enumerator);
#line 164 "../budgie-trash/trash/src/TrashStore.vala"
			_g_free0 (attributes);
#line 164 "../budgie-trash/trash/src/TrashStore.vala"
			return;
#line 1018 "TrashStore.c"
		}
#line 164 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp6_ = _tmp3_;
#line 164 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp3_ = NULL;
#line 164 "../budgie-trash/trash/src/TrashStore.vala"
		_g_object_unref0 (info);
#line 164 "../budgie-trash/trash/src/TrashStore.vala"
		info = _tmp6_;
#line 164 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp7_ = info;
#line 164 "../budgie-trash/trash/src/TrashStore.vala"
		if (!(_tmp7_ != NULL)) {
#line 164 "../budgie-trash/trash/src/TrashStore.vala"
			_g_object_unref0 (_tmp3_);
#line 164 "../budgie-trash/trash/src/TrashStore.vala"
			break;
#line 1036 "TrashStore.c"
		}
#line 165 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp8_ = g_file_get_path (dir);
#line 165 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp9_ = _tmp8_;
#line 165 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp10_ = g_strconcat (_tmp9_, "/", NULL);
#line 165 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp11_ = _tmp10_;
#line 165 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp12_ = info;
#line 165 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp13_ = g_file_info_get_name (_tmp12_);
#line 165 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp14_ = g_strconcat (_tmp11_, _tmp13_, NULL);
#line 165 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp15_ = _tmp14_;
#line 165 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp16_ = g_file_new_for_path (_tmp15_);
#line 165 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp17_ = _tmp16_;
#line 165 "../budgie-trash/trash/src/TrashStore.vala"
		_g_free0 (_tmp15_);
#line 165 "../budgie-trash/trash/src/TrashStore.vala"
		_g_free0 (_tmp11_);
#line 165 "../budgie-trash/trash/src/TrashStore.vala"
		_g_free0 (_tmp9_);
#line 165 "../budgie-trash/trash/src/TrashStore.vala"
		child = _tmp17_;
#line 167 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp18_ = info;
#line 167 "../budgie-trash/trash/src/TrashStore.vala"
		if (g_file_info_get_file_type (_tmp18_) == G_FILE_TYPE_DIRECTORY) {
#line 1070 "TrashStore.c"
			GFile* _tmp19_;
			GFile* _tmp20_;
#line 168 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp19_ = child;
#line 168 "../budgie-trash/trash/src/TrashStore.vala"
			trash_applet_trash_store_delete_directory (self, _tmp19_, &_inner_error0_);
#line 168 "../budgie-trash/trash/src/TrashStore.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 168 "../budgie-trash/trash/src/TrashStore.vala"
				g_propagate_error (error, _inner_error0_);
#line 168 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (child);
#line 168 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (_tmp3_);
#line 168 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (info);
#line 168 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (enumerator);
#line 168 "../budgie-trash/trash/src/TrashStore.vala"
				_g_free0 (attributes);
#line 168 "../budgie-trash/trash/src/TrashStore.vala"
				return;
#line 1093 "TrashStore.c"
			}
#line 169 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp20_ = child;
#line 169 "../budgie-trash/trash/src/TrashStore.vala"
			g_file_delete (_tmp20_, NULL, &_inner_error0_);
#line 169 "../budgie-trash/trash/src/TrashStore.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 169 "../budgie-trash/trash/src/TrashStore.vala"
				g_propagate_error (error, _inner_error0_);
#line 169 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (child);
#line 169 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (_tmp3_);
#line 169 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (info);
#line 169 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (enumerator);
#line 169 "../budgie-trash/trash/src/TrashStore.vala"
				_g_free0 (attributes);
#line 169 "../budgie-trash/trash/src/TrashStore.vala"
				return;
#line 1115 "TrashStore.c"
			}
		} else {
			GFile* _tmp21_;
#line 171 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp21_ = child;
#line 171 "../budgie-trash/trash/src/TrashStore.vala"
			g_file_delete (_tmp21_, NULL, &_inner_error0_);
#line 171 "../budgie-trash/trash/src/TrashStore.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 171 "../budgie-trash/trash/src/TrashStore.vala"
				g_propagate_error (error, _inner_error0_);
#line 171 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (child);
#line 171 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (_tmp3_);
#line 171 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (info);
#line 171 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (enumerator);
#line 171 "../budgie-trash/trash/src/TrashStore.vala"
				_g_free0 (attributes);
#line 171 "../budgie-trash/trash/src/TrashStore.vala"
				return;
#line 1139 "TrashStore.c"
			}
		}
#line 164 "../budgie-trash/trash/src/TrashStore.vala"
		_g_object_unref0 (child);
#line 164 "../budgie-trash/trash/src/TrashStore.vala"
		_g_object_unref0 (_tmp3_);
#line 1146 "TrashStore.c"
	}
#line 159 "../budgie-trash/trash/src/TrashStore.vala"
	_g_object_unref0 (info);
#line 159 "../budgie-trash/trash/src/TrashStore.vala"
	_g_object_unref0 (enumerator);
#line 159 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (attributes);
#line 1154 "TrashStore.c"
}

void
trash_applet_trash_store_restore_file (TrashAppletTrashStore* self,
                                       const gchar* file_name,
                                       const gchar* restore_path)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* info_file = NULL;
	GFile* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GFile* _tmp18_;
	GFile* _tmp19_;
	gchar* rpath = NULL;
	gchar* _tmp20_;
	GFile* destination = NULL;
	const gchar* _tmp21_;
	GError* _inner_error0_ = NULL;
#line 176 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_if_fail (self != NULL);
#line 176 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_if_fail (file_name != NULL);
#line 176 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_if_fail (restore_path != NULL);
#line 177 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp0_ = self->priv->trash_dir;
#line 177 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 177 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp2_ = _tmp1_;
#line 177 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp3_ = g_strconcat (_tmp2_, "/", NULL);
#line 177 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp4_ = _tmp3_;
#line 177 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp5_ = g_strconcat (_tmp4_, file_name, NULL);
#line 177 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp6_ = _tmp5_;
#line 177 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp7_ = g_file_new_for_path (_tmp6_);
#line 177 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp8_ = _tmp7_;
#line 177 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp6_);
#line 177 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp4_);
#line 177 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp2_);
#line 177 "../budgie-trash/trash/src/TrashStore.vala"
	file = _tmp8_;
#line 178 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp9_ = self->priv->info_dir;
#line 178 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp10_ = g_file_get_path (_tmp9_);
#line 178 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp11_ = _tmp10_;
#line 178 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp12_ = g_strconcat (_tmp11_, "/", NULL);
#line 178 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp13_ = _tmp12_;
#line 178 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp14_ = g_strconcat (_tmp13_, file_name, NULL);
#line 178 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp15_ = _tmp14_;
#line 178 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp16_ = g_strconcat (_tmp15_, ".trashinfo", NULL);
#line 178 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp17_ = _tmp16_;
#line 178 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp18_ = g_file_new_for_path (_tmp17_);
#line 178 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp19_ = _tmp18_;
#line 178 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp17_);
#line 178 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp15_);
#line 178 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp13_);
#line 178 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp11_);
#line 178 "../budgie-trash/trash/src/TrashStore.vala"
	info_file = _tmp19_;
#line 179 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp20_ = g_uri_unescape_string (restore_path, NULL);
#line 179 "../budgie-trash/trash/src/TrashStore.vala"
	rpath = _tmp20_;
#line 182 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp21_ = self->priv->drive_path;
#line 182 "../budgie-trash/trash/src/TrashStore.vala"
	if (_tmp21_ != NULL) {
#line 1261 "TrashStore.c"
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		GFile* _tmp28_;
#line 183 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp22_ = self->priv->drive_path;
#line 183 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp23_ = g_strconcat (_tmp22_, "/", NULL);
#line 183 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp24_ = _tmp23_;
#line 183 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp25_ = rpath;
#line 183 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp26_ = g_strconcat (_tmp24_, _tmp25_, NULL);
#line 183 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp27_ = _tmp26_;
#line 183 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp28_ = g_file_new_for_path (_tmp27_);
#line 183 "../budgie-trash/trash/src/TrashStore.vala"
		_g_object_unref0 (destination);
#line 183 "../budgie-trash/trash/src/TrashStore.vala"
		destination = _tmp28_;
#line 183 "../budgie-trash/trash/src/TrashStore.vala"
		_g_free0 (_tmp27_);
#line 183 "../budgie-trash/trash/src/TrashStore.vala"
		_g_free0 (_tmp24_);
#line 1291 "TrashStore.c"
	} else {
		const gchar* _tmp29_;
		GFile* _tmp30_;
#line 185 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp29_ = rpath;
#line 185 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp30_ = g_file_new_for_path (_tmp29_);
#line 185 "../budgie-trash/trash/src/TrashStore.vala"
		_g_object_unref0 (destination);
#line 185 "../budgie-trash/trash/src/TrashStore.vala"
		destination = _tmp30_;
#line 1303 "TrashStore.c"
	}
	{
		GFile* _tmp31_;
		GFile* _tmp32_;
		GFile* _tmp33_;
#line 189 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp31_ = file;
#line 189 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp32_ = destination;
#line 189 "../budgie-trash/trash/src/TrashStore.vala"
		g_file_move (_tmp31_, _tmp32_, G_FILE_COPY_NONE, NULL, NULL, NULL, &_inner_error0_);
#line 189 "../budgie-trash/trash/src/TrashStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1317 "TrashStore.c"
			goto __catch0_g_error;
		}
#line 190 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp33_ = info_file;
#line 190 "../budgie-trash/trash/src/TrashStore.vala"
		g_file_delete (_tmp33_, NULL, &_inner_error0_);
#line 190 "../budgie-trash/trash/src/TrashStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1326 "TrashStore.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp34_;
		GError* _tmp35_;
		const gchar* _tmp36_;
		TrashAppletApplet* _tmp37_;
		const gchar* _tmp38_;
		GError* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
#line 188 "../budgie-trash/trash/src/TrashStore.vala"
		e = _inner_error0_;
#line 188 "../budgie-trash/trash/src/TrashStore.vala"
		_inner_error0_ = NULL;
#line 192 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp34_ = rpath;
#line 192 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp35_ = e;
#line 192 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp36_ = _tmp35_->message;
#line 192 "../budgie-trash/trash/src/TrashStore.vala"
		g_warning ("TrashStore.vala:192: Unable to restore '%s' to '%s': %s", file_name, _tmp34_, _tmp36_);
#line 193 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp37_ = self->priv->applet;
#line 193 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp38_ = rpath;
#line 193 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp39_ = e;
#line 193 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp40_ = _tmp39_->message;
#line 193 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp41_ = g_strdup_printf (_ ("Unable to restore '%s' to %s: %s"), file_name, _tmp38_, _tmp40_);
#line 193 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp42_ = _tmp41_;
#line 193 "../budgie-trash/trash/src/TrashStore.vala"
		trash_applet_applet_show_notification (_tmp37_, _ ("Restore"), _tmp42_);
#line 193 "../budgie-trash/trash/src/TrashStore.vala"
		_g_free0 (_tmp42_);
#line 188 "../budgie-trash/trash/src/TrashStore.vala"
		_g_error_free0 (e);
#line 1373 "TrashStore.c"
	}
	__finally0:
#line 188 "../budgie-trash/trash/src/TrashStore.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 188 "../budgie-trash/trash/src/TrashStore.vala"
		_g_object_unref0 (destination);
#line 188 "../budgie-trash/trash/src/TrashStore.vala"
		_g_free0 (rpath);
#line 188 "../budgie-trash/trash/src/TrashStore.vala"
		_g_object_unref0 (info_file);
#line 188 "../budgie-trash/trash/src/TrashStore.vala"
		_g_object_unref0 (file);
#line 188 "../budgie-trash/trash/src/TrashStore.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 188 "../budgie-trash/trash/src/TrashStore.vala"
		g_clear_error (&_inner_error0_);
#line 188 "../budgie-trash/trash/src/TrashStore.vala"
		return;
#line 1392 "TrashStore.c"
	}
#line 176 "../budgie-trash/trash/src/TrashStore.vala"
	_g_object_unref0 (destination);
#line 176 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (rpath);
#line 176 "../budgie-trash/trash/src/TrashStore.vala"
	_g_object_unref0 (info_file);
#line 176 "../budgie-trash/trash/src/TrashStore.vala"
	_g_object_unref0 (file);
#line 1402 "TrashStore.c"
}

static void
trash_applet_trash_store_handle_trash_changed (TrashAppletTrashStore* self,
                                               GFile* file,
                                               GFile* other_file,
                                               GFileMonitorEvent event)
{
	TrashAppletApplet* _tmp27_;
	GError* _inner_error0_ = NULL;
#line 197 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_if_fail (self != NULL);
#line 197 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_if_fail (file != NULL);
#line 198 "../budgie-trash/trash/src/TrashStore.vala"
	switch (event) {
#line 198 "../budgie-trash/trash/src/TrashStore.vala"
		case G_FILE_MONITOR_EVENT_MOVED_IN:
#line 1421 "TrashStore.c"
		{
			gchar* file_name = NULL;
			gchar* _tmp0_;
			gchar* file_path = NULL;
			const gchar* _tmp1_;
			gchar* _tmp2_;
			gchar* attributes = NULL;
			gchar* _tmp3_;
			GIcon* file_icon = NULL;
			gboolean is_directory = FALSE;
			GDateTime* deletion_time = NULL;
			GDateTime* _tmp13_;
			gint _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			GIcon* _tmp17_;
			GDateTime* _tmp18_;
#line 200 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp0_ = g_file_get_basename (file);
#line 200 "../budgie-trash/trash/src/TrashStore.vala"
			file_name = _tmp0_;
#line 201 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp1_ = file_name;
#line 201 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp2_ = trash_applet_trash_store_get_path_from_trashinfo (self, _tmp1_);
#line 201 "../budgie-trash/trash/src/TrashStore.vala"
			file_path = _tmp2_;
#line 202 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp3_ = g_strdup (G_FILE_ATTRIBUTE_STANDARD_ICON "," G_FILE_ATTRIBUTE_STANDARD_TYPE);
#line 202 "../budgie-trash/trash/src/TrashStore.vala"
			attributes = _tmp3_;
#line 205 "../budgie-trash/trash/src/TrashStore.vala"
			file_icon = NULL;
#line 206 "../budgie-trash/trash/src/TrashStore.vala"
			is_directory = FALSE;
#line 1457 "TrashStore.c"
			{
				GFileInfo* file_info = NULL;
				const gchar* _tmp4_;
				GFileInfo* _tmp5_;
				GFileInfo* _tmp6_;
				GIcon* _tmp7_;
				GIcon* _tmp8_;
				GFileInfo* _tmp9_;
#line 208 "../budgie-trash/trash/src/TrashStore.vala"
				_tmp4_ = attributes;
#line 208 "../budgie-trash/trash/src/TrashStore.vala"
				_tmp5_ = g_file_query_info (file, _tmp4_, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 208 "../budgie-trash/trash/src/TrashStore.vala"
				file_info = _tmp5_;
#line 208 "../budgie-trash/trash/src/TrashStore.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1474 "TrashStore.c"
					goto __catch0_g_error;
				}
#line 209 "../budgie-trash/trash/src/TrashStore.vala"
				_tmp6_ = file_info;
#line 209 "../budgie-trash/trash/src/TrashStore.vala"
				_tmp7_ = g_file_info_get_icon (_tmp6_);
#line 209 "../budgie-trash/trash/src/TrashStore.vala"
				_tmp8_ = _g_object_ref0 (_tmp7_);
#line 209 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (file_icon);
#line 209 "../budgie-trash/trash/src/TrashStore.vala"
				file_icon = _tmp8_;
#line 211 "../budgie-trash/trash/src/TrashStore.vala"
				_tmp9_ = file_info;
#line 211 "../budgie-trash/trash/src/TrashStore.vala"
				if (g_file_info_get_file_type (_tmp9_) == G_FILE_TYPE_DIRECTORY) {
#line 212 "../budgie-trash/trash/src/TrashStore.vala"
					is_directory = TRUE;
#line 1493 "TrashStore.c"
				}
#line 207 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (file_info);
#line 1497 "TrashStore.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				const gchar* _tmp10_;
				GError* _tmp11_;
				const gchar* _tmp12_;
#line 207 "../budgie-trash/trash/src/TrashStore.vala"
				e = _inner_error0_;
#line 207 "../budgie-trash/trash/src/TrashStore.vala"
				_inner_error0_ = NULL;
#line 215 "../budgie-trash/trash/src/TrashStore.vala"
				_tmp10_ = file_name;
#line 215 "../budgie-trash/trash/src/TrashStore.vala"
				_tmp11_ = e;
#line 215 "../budgie-trash/trash/src/TrashStore.vala"
				_tmp12_ = _tmp11_->message;
#line 215 "../budgie-trash/trash/src/TrashStore.vala"
				g_warning ("TrashStore.vala:215: Unable to get icon from file info for file '%s': " \
"%s", _tmp10_, _tmp12_);
#line 216 "../budgie-trash/trash/src/TrashStore.vala"
				_g_error_free0 (e);
#line 216 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (file_icon);
#line 216 "../budgie-trash/trash/src/TrashStore.vala"
				_g_free0 (attributes);
#line 216 "../budgie-trash/trash/src/TrashStore.vala"
				_g_free0 (file_path);
#line 216 "../budgie-trash/trash/src/TrashStore.vala"
				_g_free0 (file_name);
#line 216 "../budgie-trash/trash/src/TrashStore.vala"
				break;
#line 1530 "TrashStore.c"
			}
			__finally0:
#line 207 "../budgie-trash/trash/src/TrashStore.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 207 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (file_icon);
#line 207 "../budgie-trash/trash/src/TrashStore.vala"
				_g_free0 (attributes);
#line 207 "../budgie-trash/trash/src/TrashStore.vala"
				_g_free0 (file_path);
#line 207 "../budgie-trash/trash/src/TrashStore.vala"
				_g_free0 (file_name);
#line 207 "../budgie-trash/trash/src/TrashStore.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 207 "../budgie-trash/trash/src/TrashStore.vala"
				g_clear_error (&_inner_error0_);
#line 207 "../budgie-trash/trash/src/TrashStore.vala"
				return;
#line 1549 "TrashStore.c"
			}
#line 219 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp13_ = g_date_time_new_now_local ();
#line 219 "../budgie-trash/trash/src/TrashStore.vala"
			deletion_time = _tmp13_;
#line 221 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp14_ = self->priv->_trash_count;
#line 221 "../budgie-trash/trash/src/TrashStore.vala"
			trash_applet_trash_store_set_trash_count (self, _tmp14_ + 1);
#line 222 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp15_ = file_name;
#line 222 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp16_ = file_path;
#line 222 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp17_ = file_icon;
#line 222 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp18_ = deletion_time;
#line 222 "../budgie-trash/trash/src/TrashStore.vala"
			g_signal_emit (self, trash_applet_trash_store_signals[TRASH_APPLET_TRASH_STORE_TRASH_ADDED_SIGNAL], 0, _tmp15_, _tmp16_, _tmp17_, _tmp18_, is_directory);
#line 223 "../budgie-trash/trash/src/TrashStore.vala"
			_g_date_time_unref0 (deletion_time);
#line 223 "../budgie-trash/trash/src/TrashStore.vala"
			_g_object_unref0 (file_icon);
#line 223 "../budgie-trash/trash/src/TrashStore.vala"
			_g_free0 (attributes);
#line 223 "../budgie-trash/trash/src/TrashStore.vala"
			_g_free0 (file_path);
#line 223 "../budgie-trash/trash/src/TrashStore.vala"
			_g_free0 (file_name);
#line 223 "../budgie-trash/trash/src/TrashStore.vala"
			break;
#line 1581 "TrashStore.c"
		}
#line 198 "../budgie-trash/trash/src/TrashStore.vala"
		case G_FILE_MONITOR_EVENT_MOVED_OUT:
#line 1585 "TrashStore.c"
		{
			gchar* file_name = NULL;
			gchar* _tmp19_;
			gint _tmp20_;
			const gchar* _tmp21_;
			gint _tmp22_;
#line 225 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp19_ = g_file_get_basename (file);
#line 225 "../budgie-trash/trash/src/TrashStore.vala"
			file_name = _tmp19_;
#line 226 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp20_ = self->priv->_trash_count;
#line 226 "../budgie-trash/trash/src/TrashStore.vala"
			trash_applet_trash_store_set_trash_count (self, _tmp20_ - 1);
#line 227 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp21_ = file_name;
#line 227 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp22_ = self->priv->_trash_count;
#line 227 "../budgie-trash/trash/src/TrashStore.vala"
			g_signal_emit (self, trash_applet_trash_store_signals[TRASH_APPLET_TRASH_STORE_TRASH_REMOVED_SIGNAL], 0, _tmp21_, _tmp22_ == 0);
#line 228 "../budgie-trash/trash/src/TrashStore.vala"
			_g_free0 (file_name);
#line 228 "../budgie-trash/trash/src/TrashStore.vala"
			break;
#line 1610 "TrashStore.c"
		}
#line 198 "../budgie-trash/trash/src/TrashStore.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 1614 "TrashStore.c"
		{
			gchar* file_name = NULL;
			gchar* _tmp23_;
			gint _tmp24_;
			const gchar* _tmp25_;
			gint _tmp26_;
#line 230 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp23_ = g_file_get_basename (file);
#line 230 "../budgie-trash/trash/src/TrashStore.vala"
			file_name = _tmp23_;
#line 231 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp24_ = self->priv->_trash_count;
#line 231 "../budgie-trash/trash/src/TrashStore.vala"
			trash_applet_trash_store_set_trash_count (self, _tmp24_ - 1);
#line 232 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp25_ = file_name;
#line 232 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp26_ = self->priv->_trash_count;
#line 232 "../budgie-trash/trash/src/TrashStore.vala"
			g_signal_emit (self, trash_applet_trash_store_signals[TRASH_APPLET_TRASH_STORE_TRASH_REMOVED_SIGNAL], 0, _tmp25_, _tmp26_ == 0);
#line 233 "../budgie-trash/trash/src/TrashStore.vala"
			_g_free0 (file_name);
#line 233 "../budgie-trash/trash/src/TrashStore.vala"
			break;
#line 1639 "TrashStore.c"
		}
		default:
		{
#line 235 "../budgie-trash/trash/src/TrashStore.vala"
			break;
#line 1645 "TrashStore.c"
		}
	}
#line 237 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp27_ = self->priv->applet;
#line 237 "../budgie-trash/trash/src/TrashStore.vala"
	trash_applet_applet_update_trash_icon (_tmp27_);
#line 1652 "TrashStore.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 1675 "TrashStore.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 1684 "TrashStore.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1703 "TrashStore.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1707 "TrashStore.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1713 "TrashStore.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1723 "TrashStore.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1731 "TrashStore.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1735 "TrashStore.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 1741 "TrashStore.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 1751 "TrashStore.c"
}

static gchar*
trash_applet_trash_store_get_path_from_trashinfo (TrashAppletTrashStore* self,
                                                  const gchar* file_name)
{
	GFile* info_file = NULL;
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	gchar* line = NULL;
	gchar* path = NULL;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 240 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 240 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_val_if_fail (file_name != NULL, NULL);
#line 241 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp0_ = self->priv->info_dir;
#line 241 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 241 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp2_ = _tmp1_;
#line 241 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp3_ = g_strconcat (_tmp2_, "/", NULL);
#line 241 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp4_ = _tmp3_;
#line 241 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp5_ = g_strconcat (_tmp4_, file_name, NULL);
#line 241 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp6_ = _tmp5_;
#line 241 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp7_ = g_strconcat (_tmp6_, ".trashinfo", NULL);
#line 241 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp8_ = _tmp7_;
#line 241 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp9_ = g_file_new_for_path (_tmp8_);
#line 241 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp10_ = _tmp9_;
#line 241 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp8_);
#line 241 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp6_);
#line 241 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp4_);
#line 241 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp2_);
#line 241 "../budgie-trash/trash/src/TrashStore.vala"
	info_file = _tmp10_;
#line 242 "../budgie-trash/trash/src/TrashStore.vala"
	line = NULL;
#line 243 "../budgie-trash/trash/src/TrashStore.vala"
	path = NULL;
#line 1814 "TrashStore.c"
	{
		GFileInputStream* _tmp11_ = NULL;
		GFile* _tmp12_;
		GFileInputStream* _tmp13_;
		GDataInputStream* dis = NULL;
		GDataInputStream* _tmp14_;
#line 246 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp12_ = info_file;
#line 246 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp13_ = g_file_read (_tmp12_, NULL, &_inner_error0_);
#line 246 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp11_ = _tmp13_;
#line 246 "../budgie-trash/trash/src/TrashStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1829 "TrashStore.c"
			goto __catch0_g_error;
		}
#line 246 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp14_ = g_data_input_stream_new ((GInputStream*) _tmp11_);
#line 246 "../budgie-trash/trash/src/TrashStore.vala"
		dis = _tmp14_;
#line 247 "../budgie-trash/trash/src/TrashStore.vala"
		while (TRUE) {
#line 1838 "TrashStore.c"
			gchar* _tmp15_ = NULL;
			GDataInputStream* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
#line 247 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp16_ = dis;
#line 247 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp17_ = g_data_input_stream_read_line (_tmp16_, NULL, NULL, &_inner_error0_);
#line 247 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp15_ = _tmp17_;
#line 247 "../budgie-trash/trash/src/TrashStore.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 247 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (dis);
#line 247 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (_tmp11_);
#line 1859 "TrashStore.c"
				goto __catch0_g_error;
			}
#line 247 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp18_ = _tmp15_;
#line 247 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp15_ = NULL;
#line 247 "../budgie-trash/trash/src/TrashStore.vala"
			_g_free0 (line);
#line 247 "../budgie-trash/trash/src/TrashStore.vala"
			line = _tmp18_;
#line 247 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp19_ = line;
#line 247 "../budgie-trash/trash/src/TrashStore.vala"
			if (!(_tmp19_ != NULL)) {
#line 247 "../budgie-trash/trash/src/TrashStore.vala"
				_g_free0 (_tmp15_);
#line 247 "../budgie-trash/trash/src/TrashStore.vala"
				break;
#line 1878 "TrashStore.c"
			}
#line 248 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp20_ = line;
#line 248 "../budgie-trash/trash/src/TrashStore.vala"
			if (!g_str_has_prefix (_tmp20_, "Path=")) {
#line 249 "../budgie-trash/trash/src/TrashStore.vala"
				_g_free0 (_tmp15_);
#line 249 "../budgie-trash/trash/src/TrashStore.vala"
				continue;
#line 1888 "TrashStore.c"
			}
#line 252 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp21_ = line;
#line 252 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp22_ = string_substring (_tmp21_, (glong) 5, (glong) -1);
#line 252 "../budgie-trash/trash/src/TrashStore.vala"
			_g_free0 (path);
#line 252 "../budgie-trash/trash/src/TrashStore.vala"
			path = _tmp22_;
#line 253 "../budgie-trash/trash/src/TrashStore.vala"
			_g_free0 (_tmp15_);
#line 253 "../budgie-trash/trash/src/TrashStore.vala"
			break;
#line 1902 "TrashStore.c"
		}
#line 245 "../budgie-trash/trash/src/TrashStore.vala"
		_g_object_unref0 (dis);
#line 245 "../budgie-trash/trash/src/TrashStore.vala"
		_g_object_unref0 (_tmp11_);
#line 1908 "TrashStore.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp23_;
		const gchar* _tmp24_;
#line 245 "../budgie-trash/trash/src/TrashStore.vala"
		e = _inner_error0_;
#line 245 "../budgie-trash/trash/src/TrashStore.vala"
		_inner_error0_ = NULL;
#line 256 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp23_ = e;
#line 256 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp24_ = _tmp23_->message;
#line 256 "../budgie-trash/trash/src/TrashStore.vala"
		g_warning ("TrashStore.vala:256: Error reading data from .trashinfo: %s", _tmp24_);
#line 245 "../budgie-trash/trash/src/TrashStore.vala"
		_g_error_free0 (e);
#line 1928 "TrashStore.c"
	}
	__finally0:
#line 245 "../budgie-trash/trash/src/TrashStore.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 245 "../budgie-trash/trash/src/TrashStore.vala"
		_g_free0 (path);
#line 245 "../budgie-trash/trash/src/TrashStore.vala"
		_g_free0 (line);
#line 245 "../budgie-trash/trash/src/TrashStore.vala"
		_g_object_unref0 (info_file);
#line 245 "../budgie-trash/trash/src/TrashStore.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 245 "../budgie-trash/trash/src/TrashStore.vala"
		g_clear_error (&_inner_error0_);
#line 245 "../budgie-trash/trash/src/TrashStore.vala"
		return NULL;
#line 1945 "TrashStore.c"
	}
#line 259 "../budgie-trash/trash/src/TrashStore.vala"
	result = path;
#line 259 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (line);
#line 259 "../budgie-trash/trash/src/TrashStore.vala"
	_g_object_unref0 (info_file);
#line 259 "../budgie-trash/trash/src/TrashStore.vala"
	return result;
#line 1955 "TrashStore.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1977 "TrashStore.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1981 "TrashStore.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1987 "TrashStore.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1991 "TrashStore.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1995 "TrashStore.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 2003 "TrashStore.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2031 "TrashStore.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 2040 "TrashStore.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2054 "TrashStore.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 2063 "TrashStore.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 2077 "TrashStore.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 2086 "TrashStore.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 2095 "TrashStore.c"
}

static GDateTime*
trash_applet_trash_store_get_deletion_date (TrashAppletTrashStore* self,
                                            const gchar* file_name)
{
	GFile* info_file = NULL;
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	gchar* line = NULL;
	gchar* date_string = NULL;
	const gchar* _tmp25_;
	GTimeZone* _tmp26_;
	GTimeZone* _tmp27_;
	GDateTime* _tmp28_;
	GDateTime* _tmp29_;
	GError* _inner_error0_ = NULL;
	GDateTime* result;
#line 262 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 262 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_val_if_fail (file_name != NULL, NULL);
#line 263 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp0_ = self->priv->info_dir;
#line 263 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 263 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp2_ = _tmp1_;
#line 263 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp3_ = g_strconcat (_tmp2_, "/", NULL);
#line 263 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp4_ = _tmp3_;
#line 263 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp5_ = g_strconcat (_tmp4_, file_name, NULL);
#line 263 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp6_ = _tmp5_;
#line 263 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp7_ = g_strconcat (_tmp6_, ".trashinfo", NULL);
#line 263 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp8_ = _tmp7_;
#line 263 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp9_ = g_file_new_for_path (_tmp8_);
#line 263 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp10_ = _tmp9_;
#line 263 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp8_);
#line 263 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp6_);
#line 263 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp4_);
#line 263 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (_tmp2_);
#line 263 "../budgie-trash/trash/src/TrashStore.vala"
	info_file = _tmp10_;
#line 264 "../budgie-trash/trash/src/TrashStore.vala"
	line = NULL;
#line 265 "../budgie-trash/trash/src/TrashStore.vala"
	date_string = NULL;
#line 2163 "TrashStore.c"
	{
		GFileInputStream* _tmp11_ = NULL;
		GFile* _tmp12_;
		GFileInputStream* _tmp13_;
		GDataInputStream* dis = NULL;
		GDataInputStream* _tmp14_;
#line 268 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp12_ = info_file;
#line 268 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp13_ = g_file_read (_tmp12_, NULL, &_inner_error0_);
#line 268 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp11_ = _tmp13_;
#line 268 "../budgie-trash/trash/src/TrashStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2178 "TrashStore.c"
			goto __catch0_g_error;
		}
#line 268 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp14_ = g_data_input_stream_new ((GInputStream*) _tmp11_);
#line 268 "../budgie-trash/trash/src/TrashStore.vala"
		dis = _tmp14_;
#line 269 "../budgie-trash/trash/src/TrashStore.vala"
		while (TRUE) {
#line 2187 "TrashStore.c"
			gchar* _tmp15_ = NULL;
			GDataInputStream* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
#line 269 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp16_ = dis;
#line 269 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp17_ = g_data_input_stream_read_line (_tmp16_, NULL, NULL, &_inner_error0_);
#line 269 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp15_ = _tmp17_;
#line 269 "../budgie-trash/trash/src/TrashStore.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 269 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (dis);
#line 269 "../budgie-trash/trash/src/TrashStore.vala"
				_g_object_unref0 (_tmp11_);
#line 2208 "TrashStore.c"
				goto __catch0_g_error;
			}
#line 269 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp18_ = _tmp15_;
#line 269 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp15_ = NULL;
#line 269 "../budgie-trash/trash/src/TrashStore.vala"
			_g_free0 (line);
#line 269 "../budgie-trash/trash/src/TrashStore.vala"
			line = _tmp18_;
#line 269 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp19_ = line;
#line 269 "../budgie-trash/trash/src/TrashStore.vala"
			if (!(_tmp19_ != NULL)) {
#line 269 "../budgie-trash/trash/src/TrashStore.vala"
				_g_free0 (_tmp15_);
#line 269 "../budgie-trash/trash/src/TrashStore.vala"
				break;
#line 2227 "TrashStore.c"
			}
#line 270 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp20_ = line;
#line 270 "../budgie-trash/trash/src/TrashStore.vala"
			if (!g_str_has_prefix (_tmp20_, "DeletionDate=")) {
#line 271 "../budgie-trash/trash/src/TrashStore.vala"
				_g_free0 (_tmp15_);
#line 271 "../budgie-trash/trash/src/TrashStore.vala"
				continue;
#line 2237 "TrashStore.c"
			}
#line 274 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp21_ = line;
#line 274 "../budgie-trash/trash/src/TrashStore.vala"
			_tmp22_ = string_replace (_tmp21_, "DeletionDate=", "");
#line 274 "../budgie-trash/trash/src/TrashStore.vala"
			_g_free0 (date_string);
#line 274 "../budgie-trash/trash/src/TrashStore.vala"
			date_string = _tmp22_;
#line 275 "../budgie-trash/trash/src/TrashStore.vala"
			_g_free0 (_tmp15_);
#line 275 "../budgie-trash/trash/src/TrashStore.vala"
			break;
#line 2251 "TrashStore.c"
		}
#line 267 "../budgie-trash/trash/src/TrashStore.vala"
		_g_object_unref0 (dis);
#line 267 "../budgie-trash/trash/src/TrashStore.vala"
		_g_object_unref0 (_tmp11_);
#line 2257 "TrashStore.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp23_;
		const gchar* _tmp24_;
#line 267 "../budgie-trash/trash/src/TrashStore.vala"
		e = _inner_error0_;
#line 267 "../budgie-trash/trash/src/TrashStore.vala"
		_inner_error0_ = NULL;
#line 278 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp23_ = e;
#line 278 "../budgie-trash/trash/src/TrashStore.vala"
		_tmp24_ = _tmp23_->message;
#line 278 "../budgie-trash/trash/src/TrashStore.vala"
		g_warning ("TrashStore.vala:278: Error reading data from .trashinfo: %s", _tmp24_);
#line 267 "../budgie-trash/trash/src/TrashStore.vala"
		_g_error_free0 (e);
#line 2277 "TrashStore.c"
	}
	__finally0:
#line 267 "../budgie-trash/trash/src/TrashStore.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 267 "../budgie-trash/trash/src/TrashStore.vala"
		_g_free0 (date_string);
#line 267 "../budgie-trash/trash/src/TrashStore.vala"
		_g_free0 (line);
#line 267 "../budgie-trash/trash/src/TrashStore.vala"
		_g_object_unref0 (info_file);
#line 267 "../budgie-trash/trash/src/TrashStore.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 267 "../budgie-trash/trash/src/TrashStore.vala"
		g_clear_error (&_inner_error0_);
#line 267 "../budgie-trash/trash/src/TrashStore.vala"
		return NULL;
#line 2294 "TrashStore.c"
	}
#line 281 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp25_ = date_string;
#line 281 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp26_ = g_time_zone_new_local ();
#line 281 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp27_ = _tmp26_;
#line 281 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp28_ = g_date_time_new_from_iso8601 (_tmp25_, _tmp27_);
#line 281 "../budgie-trash/trash/src/TrashStore.vala"
	_tmp29_ = _tmp28_;
#line 281 "../budgie-trash/trash/src/TrashStore.vala"
	_g_time_zone_unref0 (_tmp27_);
#line 281 "../budgie-trash/trash/src/TrashStore.vala"
	result = _tmp29_;
#line 281 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (date_string);
#line 281 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (line);
#line 281 "../budgie-trash/trash/src/TrashStore.vala"
	_g_object_unref0 (info_file);
#line 281 "../budgie-trash/trash/src/TrashStore.vala"
	return result;
#line 2318 "TrashStore.c"
}

gint
trash_applet_trash_store_get_trash_count (TrashAppletTrashStore* self)
{
	gint result;
#line 40 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 40 "../budgie-trash/trash/src/TrashStore.vala"
	result = self->priv->_trash_count;
#line 40 "../budgie-trash/trash/src/TrashStore.vala"
	return result;
#line 2331 "TrashStore.c"
}

static void
trash_applet_trash_store_set_trash_count (TrashAppletTrashStore* self,
                                          gint value)
{
#line 40 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_if_fail (self != NULL);
#line 40 "../budgie-trash/trash/src/TrashStore.vala"
	self->priv->_trash_count = value;
#line 2342 "TrashStore.c"
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING_OBJECT_BOXED_BOOLEAN (GClosure * closure,
                                                                  GValue * return_value,
                                                                  guint n_param_values,
                                                                  const GValue * param_values,
                                                                  gpointer invocation_hint,
                                                                  gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING_OBJECT_BOXED_BOOLEAN) (gpointer data1, const char* arg_1, const char* arg_2, gpointer arg_3, gpointer arg_4, gboolean arg_5, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING_OBJECT_BOXED_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_if_fail (n_param_values == 6);
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		data1 = closure->data;
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		data2 = param_values->data[0].v_pointer;
#line 2367 "TrashStore.c"
	} else {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		data1 = param_values->data[0].v_pointer;
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		data2 = closure->data;
#line 2373 "TrashStore.c"
	}
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	callback = (GMarshalFunc_VOID__STRING_STRING_OBJECT_BOXED_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), g_value_get_object (param_values + 3), g_value_get_boxed (param_values + 4), g_value_get_boolean (param_values + 5), data2);
#line 2379 "TrashStore.c"
}

static void
g_cclosure_user_marshal_VOID__STRING_BOOLEAN (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_BOOLEAN) (gpointer data1, const char* arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_if_fail (n_param_values == 3);
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		data1 = closure->data;
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		data2 = param_values->data[0].v_pointer;
#line 2404 "TrashStore.c"
	} else {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		data1 = param_values->data[0].v_pointer;
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		data2 = closure->data;
#line 2410 "TrashStore.c"
	}
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	callback = (GMarshalFunc_VOID__STRING_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 2416 "TrashStore.c"
}

static void
trash_applet_value_trash_store_init (GValue* value)
{
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	value->data[0].v_pointer = NULL;
#line 2424 "TrashStore.c"
}

static void
trash_applet_value_trash_store_free_value (GValue* value)
{
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	if (value->data[0].v_pointer) {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		trash_applet_trash_store_unref (value->data[0].v_pointer);
#line 2434 "TrashStore.c"
	}
}

static void
trash_applet_value_trash_store_copy_value (const GValue* src_value,
                                           GValue* dest_value)
{
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	if (src_value->data[0].v_pointer) {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		dest_value->data[0].v_pointer = trash_applet_trash_store_ref (src_value->data[0].v_pointer);
#line 2446 "TrashStore.c"
	} else {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2450 "TrashStore.c"
	}
}

static gpointer
trash_applet_value_trash_store_peek_pointer (const GValue* value)
{
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	return value->data[0].v_pointer;
#line 2459 "TrashStore.c"
}

static gchar*
trash_applet_value_trash_store_collect_value (GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	if (collect_values[0].v_pointer) {
#line 2470 "TrashStore.c"
		TrashAppletTrashStore * object;
		object = collect_values[0].v_pointer;
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		if (object->parent_instance.g_class == NULL) {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2477 "TrashStore.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2481 "TrashStore.c"
		}
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		value->data[0].v_pointer = trash_applet_trash_store_ref (object);
#line 2485 "TrashStore.c"
	} else {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		value->data[0].v_pointer = NULL;
#line 2489 "TrashStore.c"
	}
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	return NULL;
#line 2493 "TrashStore.c"
}

static gchar*
trash_applet_value_trash_store_lcopy_value (const GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
	TrashAppletTrashStore ** object_p;
	object_p = collect_values[0].v_pointer;
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	if (!object_p) {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2508 "TrashStore.c"
	}
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	if (!value->data[0].v_pointer) {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		*object_p = NULL;
#line 2514 "TrashStore.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		*object_p = value->data[0].v_pointer;
#line 2518 "TrashStore.c"
	} else {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		*object_p = trash_applet_trash_store_ref (value->data[0].v_pointer);
#line 2522 "TrashStore.c"
	}
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	return NULL;
#line 2526 "TrashStore.c"
}

GParamSpec*
trash_applet_param_spec_trash_store (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags)
{
	TrashAppletParamSpecTrashStore* spec;
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TRASH_APPLET_TYPE_TRASH_STORE), NULL);
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	return G_PARAM_SPEC (spec);
#line 2545 "TrashStore.c"
}

gpointer
trash_applet_value_get_trash_store (const GValue* value)
{
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TRASH_APPLET_TYPE_TRASH_STORE), NULL);
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	return value->data[0].v_pointer;
#line 2555 "TrashStore.c"
}

void
trash_applet_value_set_trash_store (GValue* value,
                                    gpointer v_object)
{
	TrashAppletTrashStore * old;
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TRASH_APPLET_TYPE_TRASH_STORE));
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	old = value->data[0].v_pointer;
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	if (v_object) {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TRASH_APPLET_TYPE_TRASH_STORE));
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		value->data[0].v_pointer = v_object;
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		trash_applet_trash_store_ref (value->data[0].v_pointer);
#line 2577 "TrashStore.c"
	} else {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		value->data[0].v_pointer = NULL;
#line 2581 "TrashStore.c"
	}
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	if (old) {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		trash_applet_trash_store_unref (old);
#line 2587 "TrashStore.c"
	}
}

void
trash_applet_value_take_trash_store (GValue* value,
                                     gpointer v_object)
{
	TrashAppletTrashStore * old;
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TRASH_APPLET_TYPE_TRASH_STORE));
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	old = value->data[0].v_pointer;
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	if (v_object) {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TRASH_APPLET_TYPE_TRASH_STORE));
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		value->data[0].v_pointer = v_object;
#line 2608 "TrashStore.c"
	} else {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		value->data[0].v_pointer = NULL;
#line 2612 "TrashStore.c"
	}
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	if (old) {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		trash_applet_trash_store_unref (old);
#line 2618 "TrashStore.c"
	}
}

static void
trash_applet_trash_store_class_init (TrashAppletTrashStoreClass * klass,
                                     gpointer klass_data)
{
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	trash_applet_trash_store_parent_class = g_type_class_peek_parent (klass);
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	((TrashAppletTrashStoreClass *) klass)->finalize = trash_applet_trash_store_finalize;
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	g_type_class_adjust_private_offset (klass, &TrashAppletTrashStore_private_offset);
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	trash_applet_trash_store_signals[TRASH_APPLET_TRASH_STORE_TRASH_ADDED_SIGNAL] = g_signal_new ("trash-added", TRASH_APPLET_TYPE_TRASH_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_OBJECT_BOXED_BOOLEAN, G_TYPE_NONE, 5, G_TYPE_STRING, G_TYPE_STRING, g_icon_get_type (), G_TYPE_DATE_TIME, G_TYPE_BOOLEAN);
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	trash_applet_trash_store_signals[TRASH_APPLET_TRASH_STORE_TRASH_REMOVED_SIGNAL] = g_signal_new ("trash-removed", TRASH_APPLET_TYPE_TRASH_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_BOOLEAN);
#line 2636 "TrashStore.c"
}

static void
trash_applet_trash_store_instance_init (TrashAppletTrashStore * self,
                                        gpointer klass)
{
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	self->priv = trash_applet_trash_store_get_instance_private (self);
#line 40 "../budgie-trash/trash/src/TrashStore.vala"
	self->priv->_trash_count = 0;
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	self->ref_count = 1;
#line 2649 "TrashStore.c"
}

static void
trash_applet_trash_store_finalize (TrashAppletTrashStore * obj)
{
	TrashAppletTrashStore * self;
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TRASH_APPLET_TYPE_TRASH_STORE, TrashAppletTrashStore);
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	g_signal_handlers_destroy (self);
#line 30 "../budgie-trash/trash/src/TrashStore.vala"
	_g_object_unref0 (self->priv->applet);
#line 31 "../budgie-trash/trash/src/TrashStore.vala"
	_g_object_unref0 (self->priv->trash_dir);
#line 32 "../budgie-trash/trash/src/TrashStore.vala"
	_g_object_unref0 (self->priv->info_dir);
#line 34 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (self->priv->drive_name);
#line 35 "../budgie-trash/trash/src/TrashStore.vala"
	_g_free0 (self->priv->drive_path);
#line 36 "../budgie-trash/trash/src/TrashStore.vala"
	_g_object_unref0 (self->priv->drive_icon);
#line 38 "../budgie-trash/trash/src/TrashStore.vala"
	_g_object_unref0 (self->priv->trash_monitor);
#line 2674 "TrashStore.c"
}

/**
     * TrashStore represents a trash bin on the user's system.
     *
     * Removable drives may have their own trash locations that should be tracked,
     * along with the user's main trash bin.
     */
GType
trash_applet_trash_store_get_type (void)
{
	return trash_applet_trash_store_type_id;
}

GType
trash_applet_trash_store_register_type (GTypeModule * module)
{
	static const GTypeValueTable g_define_type_value_table = { trash_applet_value_trash_store_init, trash_applet_value_trash_store_free_value, trash_applet_value_trash_store_copy_value, trash_applet_value_trash_store_peek_pointer, "p", trash_applet_value_trash_store_collect_value, "p", trash_applet_value_trash_store_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TrashAppletTrashStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) trash_applet_trash_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TrashAppletTrashStore), 0, (GInstanceInitFunc) trash_applet_trash_store_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	trash_applet_trash_store_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TrashAppletTrashStore", &g_define_type_info, &g_define_type_fundamental_info, 0);
	TrashAppletTrashStore_private_offset = sizeof (TrashAppletTrashStorePrivate);
	return trash_applet_trash_store_type_id;
}

gpointer
trash_applet_trash_store_ref (gpointer instance)
{
	TrashAppletTrashStore * self;
	self = instance;
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	g_atomic_int_inc (&self->ref_count);
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	return instance;
#line 2709 "TrashStore.c"
}

void
trash_applet_trash_store_unref (gpointer instance)
{
	TrashAppletTrashStore * self;
	self = instance;
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		TRASH_APPLET_TRASH_STORE_GET_CLASS (self)->finalize (self);
#line 29 "../budgie-trash/trash/src/TrashStore.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2723 "TrashStore.c"
	}
}

