/* TrashItem.c generated by valac 0.56.8, the Vala compiler
 * generated from TrashItem.vala, do not modify */

/*
 * This file is part of UbuntuBudgie
 *
 * Copyright 2019 Evan Maddock, 2021 Ubuntu Budgie Developers
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "trashapplet.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>

enum  {
	TRASH_APPLET_WIDGETS_TRASH_ITEM_0_PROPERTY,
	TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_PATH_PROPERTY,
	TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_NAME_PROPERTY,
	TRASH_APPLET_WIDGETS_TRASH_ITEM_IS_DIRECTORY_PROPERTY,
	TRASH_APPLET_WIDGETS_TRASH_ITEM_DELETION_TIME_PROPERTY,
	TRASH_APPLET_WIDGETS_TRASH_ITEM_NUM_PROPERTIES
};
static GParamSpec* trash_applet_widgets_trash_item_properties[TRASH_APPLET_WIDGETS_TRASH_ITEM_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	TRASH_APPLET_WIDGETS_TRASH_ITEM_ON_DELETE_SIGNAL,
	TRASH_APPLET_WIDGETS_TRASH_ITEM_ON_RESTORE_SIGNAL,
	TRASH_APPLET_WIDGETS_TRASH_ITEM_NUM_SIGNALS
};
static guint trash_applet_widgets_trash_item_signals[TRASH_APPLET_WIDGETS_TRASH_ITEM_NUM_SIGNALS] = {0};

struct _TrashAppletWidgetsTrashItemPrivate {
	gboolean restoring;
	gchar* _file_path;
	gchar* _file_name;
	gboolean _is_directory;
	GDateTime* _deletion_time;
	GtkBox* file_container;
	GtkImage* file_icon;
	GtkLabel* display_text;
	GtkButton* restore_button;
	GtkButton* delete_button;
	GtkRevealer* info_revealer;
	GtkBox* info_container;
	GtkLabel* path_label;
	GtkLabel* date_label;
	GtkRevealer* revealer;
	GtkBox* revealer_container;
	GtkLabel* revealer_text;
	GtkBox* revealer_buttons;
	GtkButton* go_back_button;
	GtkButton* confirm_button;
};

static gint TrashAppletWidgetsTrashItem_private_offset;
static gpointer trash_applet_widgets_trash_item_parent_class = NULL;
static GType trash_applet_widgets_trash_item_type_id = 0;

static void trash_applet_widgets_trash_item_set_file_path (TrashAppletWidgetsTrashItem* self,
                                                    const gchar* value);
static void trash_applet_widgets_trash_item_set_file_name (TrashAppletWidgetsTrashItem* self,
                                                    const gchar* value);
static void trash_applet_widgets_trash_item_set_deletion_time (TrashAppletWidgetsTrashItem* self,
                                                        GDateTime* value);
static void trash_applet_widgets_trash_item_set_is_directory (TrashAppletWidgetsTrashItem* self,
                                                       gboolean value);
static void trash_applet_widgets_trash_item_apply_button_styles (TrashAppletWidgetsTrashItem* self);
static void trash_applet_widgets_trash_item_connect_signals (TrashAppletWidgetsTrashItem* self);
static void __lambda7_ (TrashAppletWidgetsTrashItem* self);
static void trash_applet_widgets_trash_item_show_confirmation (TrashAppletWidgetsTrashItem* self,
                                                        gboolean restore);
static void ___lambda7__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void __lambda8_ (TrashAppletWidgetsTrashItem* self);
static void ___lambda8__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void __lambda9_ (TrashAppletWidgetsTrashItem* self);
static void ___lambda9__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void __lambda10_ (TrashAppletWidgetsTrashItem* self);
static void ___lambda10__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void trash_applet_widgets_trash_item_finalize (GObject * obj);
static void _vala_trash_applet_widgets_trash_item_get_property (GObject * object,
                                                         guint property_id,
                                                         GValue * value,
                                                         GParamSpec * pspec);
static void _vala_trash_applet_widgets_trash_item_set_property (GObject * object,
                                                         guint property_id,
                                                         const GValue * value,
                                                         GParamSpec * pspec);

static inline gpointer
trash_applet_widgets_trash_item_get_instance_private (TrashAppletWidgetsTrashItem* self)
{
	return G_STRUCT_MEMBER_P (self, TrashAppletWidgetsTrashItem_private_offset);
}

/**
         * Constructor
         */
TrashAppletWidgetsTrashItem*
trash_applet_widgets_trash_item_construct (GType object_type,
                                           const gchar* file_path,
                                           const gchar* file_name,
                                           GIcon* glib_icon,
                                           GDateTime* deletion_time,
                                           gboolean is_directory)
{
	TrashAppletWidgetsTrashItem * self = NULL;
	GtkStyleContext* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkImage* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkButton* _tmp9_;
	GtkButton* _tmp10_;
	GtkButton* _tmp11_;
	GtkButton* _tmp12_;
	GtkBox* _tmp13_;
	GtkImage* _tmp14_;
	GtkBox* _tmp15_;
	GtkLabel* _tmp16_;
	GtkBox* _tmp17_;
	GtkButton* _tmp18_;
	GtkBox* _tmp19_;
	GtkButton* _tmp20_;
	GtkRevealer* _tmp21_;
	GtkRevealer* _tmp22_;
	GtkRevealer* _tmp23_;
	GtkRevealer* _tmp24_;
	GtkStyleContext* _tmp25_;
	GtkBox* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	GtkLabel* _tmp29_;
	GtkLabel* _tmp30_;
	GtkLabel* _tmp31_;
	GtkLabel* _tmp32_;
	GtkLabel* _tmp33_;
	gchar* time = NULL;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	GtkLabel* _tmp37_;
	GtkLabel* _tmp38_;
	GtkLabel* _tmp39_;
	GtkBox* _tmp40_;
	GtkLabel* _tmp41_;
	GtkBox* _tmp42_;
	GtkLabel* _tmp43_;
	GtkRevealer* _tmp44_;
	GtkBox* _tmp45_;
	GtkRevealer* _tmp46_;
	GtkRevealer* _tmp47_;
	GtkRevealer* _tmp48_;
	GtkBox* _tmp49_;
	GtkLabel* _tmp50_;
	GtkLabel* _tmp51_;
	GtkBox* _tmp52_;
	GtkButton* _tmp53_;
	GtkButton* _tmp54_;
	GtkBox* _tmp55_;
	GtkButton* _tmp56_;
	GtkBox* _tmp57_;
	GtkButton* _tmp58_;
	GtkBox* _tmp59_;
	GtkLabel* _tmp60_;
	GtkBox* _tmp61_;
	GtkBox* _tmp62_;
	GtkRevealer* _tmp63_;
	GtkBox* _tmp64_;
	GtkBox* _tmp65_;
	GtkRevealer* _tmp66_;
	GtkRevealer* _tmp67_;
#line 60 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 60 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_return_val_if_fail (file_name != NULL, NULL);
#line 60 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_return_val_if_fail (glib_icon != NULL, NULL);
#line 60 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_return_val_if_fail (deletion_time != NULL, NULL);
#line 61 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self = (TrashAppletWidgetsTrashItem*) g_object_new (object_type, "orientation", GTK_ORIENTATION_VERTICAL, "spacing", 0, NULL);
#line 62 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	trash_applet_widgets_trash_item_set_file_path (self, file_path);
#line 63 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	trash_applet_widgets_trash_item_set_file_name (self, file_name);
#line 64 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	trash_applet_widgets_trash_item_set_deletion_time (self, deletion_time);
#line 65 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	trash_applet_widgets_trash_item_set_is_directory (self, is_directory);
#line 67 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 67 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_style_context_add_class (_tmp0_, "trash-item");
#line 70 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 70 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_ref_sink (_tmp1_);
#line 70 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->file_container);
#line 70 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->file_container = _tmp1_;
#line 71 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp2_ = self->priv->file_container;
#line 71 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_set ((GtkWidget*) _tmp2_, "height-request", 32, NULL);
#line 72 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp3_ = (GtkImage*) gtk_image_new_from_gicon (glib_icon, (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 72 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_ref_sink (_tmp3_);
#line 72 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->file_icon);
#line 72 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->file_icon = _tmp3_;
#line 73 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new (file_name);
#line 73 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_ref_sink (_tmp4_);
#line 73 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->display_text);
#line 73 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->display_text = _tmp4_;
#line 74 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp5_ = self->priv->display_text;
#line 74 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_label_set_max_width_chars (_tmp5_, 30);
#line 75 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp6_ = self->priv->display_text;
#line 75 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_label_set_ellipsize (_tmp6_, PANGO_ELLIPSIZE_END);
#line 76 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp7_ = self->priv->display_text;
#line 76 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_START);
#line 77 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp8_ = self->priv->display_text;
#line 77 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_label_set_justify (_tmp8_, GTK_JUSTIFY_LEFT);
#line 79 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp9_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-undo-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 79 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_ref_sink (_tmp9_);
#line 79 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->restore_button);
#line 79 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->restore_button = _tmp9_;
#line 80 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp10_ = self->priv->restore_button;
#line 80 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp10_, _ ("Restore item"));
#line 81 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp11_ = (GtkButton*) gtk_button_new_from_icon_name ("user-trash-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 81 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_ref_sink (_tmp11_);
#line 81 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->delete_button);
#line 81 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->delete_button = _tmp11_;
#line 82 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp12_ = self->priv->delete_button;
#line 82 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp12_, _ ("Delete item"));
#line 84 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp13_ = self->priv->file_container;
#line 84 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp14_ = self->priv->file_icon;
#line 84 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_box_pack_start (_tmp13_, (GtkWidget*) _tmp14_, FALSE, FALSE, (guint) 5);
#line 85 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp15_ = self->priv->file_container;
#line 85 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp16_ = self->priv->display_text;
#line 85 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_box_pack_start (_tmp15_, (GtkWidget*) _tmp16_, TRUE, TRUE, (guint) 0);
#line 86 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp17_ = self->priv->file_container;
#line 86 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp18_ = self->priv->delete_button;
#line 86 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_box_pack_end (_tmp17_, (GtkWidget*) _tmp18_, FALSE, FALSE, (guint) 0);
#line 87 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp19_ = self->priv->file_container;
#line 87 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp20_ = self->priv->restore_button;
#line 87 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_box_pack_end (_tmp19_, (GtkWidget*) _tmp20_, FALSE, FALSE, (guint) 0);
#line 89 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp21_ = (GtkRevealer*) gtk_revealer_new ();
#line 89 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_ref_sink (_tmp21_);
#line 89 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->info_revealer);
#line 89 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->info_revealer = _tmp21_;
#line 90 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp22_ = self->priv->info_revealer;
#line 90 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_revealer_set_transition_type (_tmp22_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
#line 91 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp23_ = self->priv->info_revealer;
#line 91 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_revealer_set_reveal_child (_tmp23_, FALSE);
#line 92 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp24_ = self->priv->info_revealer;
#line 92 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp25_ = gtk_widget_get_style_context ((GtkWidget*) _tmp24_);
#line 92 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_style_context_add_class (_tmp25_, "trash-info-revealer");
#line 93 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp26_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 5);
#line 93 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_ref_sink (_tmp26_);
#line 93 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->info_container);
#line 93 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->info_container = _tmp26_;
#line 95 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp27_ = g_strdup_printf (_ ("Path: %s"), file_path);
#line 95 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp28_ = _tmp27_;
#line 95 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp29_ = (GtkLabel*) gtk_label_new (_tmp28_);
#line 95 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_ref_sink (_tmp29_);
#line 95 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->path_label);
#line 95 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->path_label = _tmp29_;
#line 95 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_free0 (_tmp28_);
#line 96 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp30_ = self->priv->path_label;
#line 96 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp30_, file_path);
#line 97 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp31_ = self->priv->path_label;
#line 97 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_label_set_ellipsize (_tmp31_, PANGO_ELLIPSIZE_END);
#line 98 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp32_ = self->priv->path_label;
#line 98 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp32_, GTK_ALIGN_START);
#line 99 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp33_ = self->priv->path_label;
#line 99 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_label_set_justify (_tmp33_, GTK_JUSTIFY_LEFT);
#line 101 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp34_ = g_date_time_format (deletion_time, "%Y-%m-%d %H:%M %Z");
#line 101 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	time = _tmp34_;
#line 103 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp35_ = g_strdup_printf (_ ("Deleted on: %s"), time);
#line 103 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp36_ = _tmp35_;
#line 103 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp37_ = (GtkLabel*) gtk_label_new (_tmp36_);
#line 103 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_ref_sink (_tmp37_);
#line 103 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->date_label);
#line 103 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->date_label = _tmp37_;
#line 103 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_free0 (_tmp36_);
#line 104 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp38_ = self->priv->date_label;
#line 104 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp38_, GTK_ALIGN_START);
#line 105 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp39_ = self->priv->date_label;
#line 105 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_label_set_justify (_tmp39_, GTK_JUSTIFY_LEFT);
#line 107 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp40_ = self->priv->info_container;
#line 107 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp41_ = self->priv->path_label;
#line 107 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_box_pack_start (_tmp40_, (GtkWidget*) _tmp41_, TRUE, TRUE, (guint) 0);
#line 108 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp42_ = self->priv->info_container;
#line 108 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp43_ = self->priv->date_label;
#line 108 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_box_pack_start (_tmp42_, (GtkWidget*) _tmp43_, TRUE, TRUE, (guint) 0);
#line 109 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp44_ = self->priv->info_revealer;
#line 109 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp45_ = self->priv->info_container;
#line 109 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_container_add ((GtkContainer*) _tmp44_, (GtkWidget*) _tmp45_);
#line 111 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp46_ = (GtkRevealer*) gtk_revealer_new ();
#line 111 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_ref_sink (_tmp46_);
#line 111 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->revealer);
#line 111 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->revealer = _tmp46_;
#line 112 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp47_ = self->priv->revealer;
#line 112 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_revealer_set_transition_type (_tmp47_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
#line 113 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp48_ = self->priv->revealer;
#line 113 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_revealer_set_reveal_child (_tmp48_, FALSE);
#line 114 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp49_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 5);
#line 114 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_ref_sink (_tmp49_);
#line 114 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->revealer_container);
#line 114 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->revealer_container = _tmp49_;
#line 115 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp50_ = (GtkLabel*) gtk_label_new ("");
#line 115 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_ref_sink (_tmp50_);
#line 115 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->revealer_text);
#line 115 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->revealer_text = _tmp50_;
#line 116 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp51_ = self->priv->revealer_text;
#line 116 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_set ((GtkWidget*) _tmp51_, "height-request", 20, NULL);
#line 118 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp52_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 118 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_ref_sink (_tmp52_);
#line 118 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->revealer_buttons);
#line 118 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->revealer_buttons = _tmp52_;
#line 119 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp53_ = (GtkButton*) gtk_button_new_with_label (_ ("No"));
#line 119 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_ref_sink (_tmp53_);
#line 119 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->go_back_button);
#line 119 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->go_back_button = _tmp53_;
#line 120 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp54_ = (GtkButton*) gtk_button_new_with_label (_ ("Yes"));
#line 120 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_ref_sink (_tmp54_);
#line 120 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->confirm_button);
#line 120 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->confirm_button = _tmp54_;
#line 121 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp55_ = self->priv->revealer_buttons;
#line 121 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp56_ = self->priv->go_back_button;
#line 121 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_box_pack_start (_tmp55_, (GtkWidget*) _tmp56_, TRUE, TRUE, (guint) 0);
#line 122 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp57_ = self->priv->revealer_buttons;
#line 122 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp58_ = self->priv->confirm_button;
#line 122 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_box_pack_end (_tmp57_, (GtkWidget*) _tmp58_, TRUE, TRUE, (guint) 0);
#line 124 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp59_ = self->priv->revealer_container;
#line 124 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp60_ = self->priv->revealer_text;
#line 124 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_box_pack_start (_tmp59_, (GtkWidget*) _tmp60_, TRUE, TRUE, (guint) 0);
#line 125 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp61_ = self->priv->revealer_container;
#line 125 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp62_ = self->priv->revealer_buttons;
#line 125 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_box_pack_end (_tmp61_, (GtkWidget*) _tmp62_, TRUE, TRUE, (guint) 0);
#line 126 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp63_ = self->priv->revealer;
#line 126 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp64_ = self->priv->revealer_container;
#line 126 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_container_add ((GtkContainer*) _tmp63_, (GtkWidget*) _tmp64_);
#line 128 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	trash_applet_widgets_trash_item_apply_button_styles (self);
#line 129 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	trash_applet_widgets_trash_item_connect_signals (self);
#line 131 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp65_ = self->priv->file_container;
#line 131 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp65_, TRUE, TRUE, (guint) 0);
#line 132 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp66_ = self->priv->revealer;
#line 132 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_box_pack_end ((GtkBox*) self, (GtkWidget*) _tmp66_, FALSE, FALSE, (guint) 0);
#line 133 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp67_ = self->priv->info_revealer;
#line 133 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_box_pack_end ((GtkBox*) self, (GtkWidget*) _tmp67_, FALSE, FALSE, (guint) 0);
#line 134 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 60 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_free0 (time);
#line 60 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	return self;
#line 536 "TrashItem.c"
}

TrashAppletWidgetsTrashItem*
trash_applet_widgets_trash_item_new (const gchar* file_path,
                                     const gchar* file_name,
                                     GIcon* glib_icon,
                                     GDateTime* deletion_time,
                                     gboolean is_directory)
{
#line 60 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	return trash_applet_widgets_trash_item_construct (TRASH_APPLET_WIDGETS_TYPE_TRASH_ITEM, file_path, file_name, glib_icon, deletion_time, is_directory);
#line 548 "TrashItem.c"
}

void
trash_applet_widgets_trash_item_toggle_info_revealer (TrashAppletWidgetsTrashItem* self)
{
	GtkRevealer* _tmp0_;
#line 137 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_return_if_fail (self != NULL);
#line 138 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp0_ = self->priv->info_revealer;
#line 138 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	if (gtk_revealer_get_reveal_child (_tmp0_)) {
#line 561 "TrashItem.c"
		GtkRevealer* _tmp1_;
#line 139 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		_tmp1_ = self->priv->info_revealer;
#line 139 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		gtk_revealer_set_reveal_child (_tmp1_, FALSE);
#line 567 "TrashItem.c"
	} else {
		GtkRevealer* _tmp2_;
#line 141 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		_tmp2_ = self->priv->info_revealer;
#line 141 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		gtk_revealer_set_reveal_child (_tmp2_, TRUE);
#line 574 "TrashItem.c"
	}
}

static void
trash_applet_widgets_trash_item_apply_button_styles (TrashAppletWidgetsTrashItem* self)
{
	GtkButton* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkButton* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkButton* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkButton* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkButton* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkButton* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkButton* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkButton* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkButton* _tmp16_;
	GtkStyleContext* _tmp17_;
#line 145 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_return_if_fail (self != NULL);
#line 146 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp0_ = self->priv->restore_button;
#line 146 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) _tmp0_);
#line 146 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_style_context_add_class (_tmp1_, "flat");
#line 147 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp2_ = self->priv->delete_button;
#line 147 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
#line 147 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_style_context_add_class (_tmp3_, "flat");
#line 148 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp4_ = self->priv->go_back_button;
#line 148 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 148 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_style_context_add_class (_tmp5_, "flat");
#line 149 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp6_ = self->priv->confirm_button;
#line 149 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
#line 149 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_style_context_add_class (_tmp7_, "flat");
#line 150 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp8_ = self->priv->confirm_button;
#line 150 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
#line 150 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_style_context_add_class (_tmp9_, "destructive-action");
#line 152 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp10_ = self->priv->restore_button;
#line 152 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
#line 152 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_style_context_remove_class (_tmp11_, "button");
#line 153 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp12_ = self->priv->delete_button;
#line 153 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) _tmp12_);
#line 153 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_style_context_remove_class (_tmp13_, "button");
#line 154 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp14_ = self->priv->go_back_button;
#line 154 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
#line 154 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_style_context_remove_class (_tmp15_, "button");
#line 155 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp16_ = self->priv->confirm_button;
#line 155 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp17_ = gtk_widget_get_style_context ((GtkWidget*) _tmp16_);
#line 155 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_style_context_remove_class (_tmp17_, "button");
#line 655 "TrashItem.c"
}

static void
__lambda7_ (TrashAppletWidgetsTrashItem* self)
{
#line 160 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	trash_applet_widgets_trash_item_show_confirmation (self, FALSE);
#line 663 "TrashItem.c"
}

static void
___lambda7__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 159 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	__lambda7_ ((TrashAppletWidgetsTrashItem*) self);
#line 672 "TrashItem.c"
}

static void
__lambda8_ (TrashAppletWidgetsTrashItem* self)
{
#line 164 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	trash_applet_widgets_trash_item_show_confirmation (self, TRUE);
#line 680 "TrashItem.c"
}

static void
___lambda8__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 163 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	__lambda8_ ((TrashAppletWidgetsTrashItem*) self);
#line 689 "TrashItem.c"
}

static void
__lambda9_ (TrashAppletWidgetsTrashItem* self)
{
#line 168 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	if (self->priv->restoring) {
#line 697 "TrashItem.c"
		const gchar* _tmp0_;
		const gchar* _tmp1_;
#line 169 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		_tmp0_ = self->priv->_file_name;
#line 169 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		_tmp1_ = self->priv->_file_path;
#line 169 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		g_signal_emit (self, trash_applet_widgets_trash_item_signals[TRASH_APPLET_WIDGETS_TRASH_ITEM_ON_RESTORE_SIGNAL], 0, _tmp0_, _tmp1_);
#line 706 "TrashItem.c"
	} else {
		const gchar* _tmp2_;
#line 171 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		_tmp2_ = self->priv->_file_name;
#line 171 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		g_signal_emit (self, trash_applet_widgets_trash_item_signals[TRASH_APPLET_WIDGETS_TRASH_ITEM_ON_DELETE_SIGNAL], 0, _tmp2_);
#line 713 "TrashItem.c"
	}
}

static void
___lambda9__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 167 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	__lambda9_ ((TrashAppletWidgetsTrashItem*) self);
#line 723 "TrashItem.c"
}

static void
__lambda10_ (TrashAppletWidgetsTrashItem* self)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkRevealer* _tmp2_;
#line 176 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp0_ = self->priv->restore_button;
#line 176 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
#line 177 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp1_ = self->priv->delete_button;
#line 177 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, TRUE);
#line 178 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp2_ = self->priv->revealer;
#line 178 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_revealer_set_reveal_child (_tmp2_, FALSE);
#line 744 "TrashItem.c"
}

static void
___lambda10__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 175 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	__lambda10_ ((TrashAppletWidgetsTrashItem*) self);
#line 753 "TrashItem.c"
}

static void
trash_applet_widgets_trash_item_connect_signals (TrashAppletWidgetsTrashItem* self)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
#line 158 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_return_if_fail (self != NULL);
#line 159 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp0_ = self->priv->delete_button;
#line 159 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_signal_connect_object (_tmp0_, "clicked", (GCallback) ___lambda7__gtk_button_clicked, self, 0);
#line 163 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp1_ = self->priv->restore_button;
#line 163 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_signal_connect_object (_tmp1_, "clicked", (GCallback) ___lambda8__gtk_button_clicked, self, 0);
#line 167 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp2_ = self->priv->confirm_button;
#line 167 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_signal_connect_object (_tmp2_, "clicked", (GCallback) ___lambda9__gtk_button_clicked, self, 0);
#line 175 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp3_ = self->priv->go_back_button;
#line 175 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_signal_connect_object (_tmp3_, "clicked", (GCallback) ___lambda10__gtk_button_clicked, self, 0);
#line 781 "TrashItem.c"
}

static void
trash_applet_widgets_trash_item_show_confirmation (TrashAppletWidgetsTrashItem* self,
                                                   gboolean restore)
{
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
	GtkRevealer* _tmp8_;
#line 182 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_return_if_fail (self != NULL);
#line 183 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->restoring = restore;
#line 185 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	if (restore) {
#line 797 "TrashItem.c"
		GtkLabel* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 186 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		_tmp0_ = self->priv->revealer_text;
#line 186 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		_tmp1_ = g_strdup_printf ("<b>%s</b>", _ ("Restore this item?"));
#line 186 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		_tmp2_ = _tmp1_;
#line 186 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		gtk_label_set_markup (_tmp0_, _tmp2_);
#line 186 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		_g_free0 (_tmp2_);
#line 811 "TrashItem.c"
	} else {
		GtkLabel* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 188 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		_tmp3_ = self->priv->revealer_text;
#line 188 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		_tmp4_ = g_strdup_printf ("<b>%s</b>", _ ("Delete this item?"));
#line 188 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		_tmp5_ = _tmp4_;
#line 188 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		gtk_label_set_markup (_tmp3_, _tmp5_);
#line 188 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		_g_free0 (_tmp5_);
#line 826 "TrashItem.c"
	}
#line 191 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp6_ = self->priv->restore_button;
#line 191 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, FALSE);
#line 192 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp7_ = self->priv->delete_button;
#line 192 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, FALSE);
#line 193 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp8_ = self->priv->revealer;
#line 193 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	gtk_revealer_set_reveal_child (_tmp8_, TRUE);
#line 840 "TrashItem.c"
}

const gchar*
trash_applet_widgets_trash_item_get_file_path (TrashAppletWidgetsTrashItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 29 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp0_ = self->priv->_file_path;
#line 29 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	result = _tmp0_;
#line 29 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	return result;
#line 856 "TrashItem.c"
}

static void
trash_applet_widgets_trash_item_set_file_path (TrashAppletWidgetsTrashItem* self,
                                               const gchar* value)
{
	gchar* old_value;
#line 29 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_return_if_fail (self != NULL);
#line 29 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	old_value = trash_applet_widgets_trash_item_get_file_path (self);
#line 29 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 870 "TrashItem.c"
		gchar* _tmp0_;
#line 29 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		_tmp0_ = g_strdup (value);
#line 29 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		_g_free0 (self->priv->_file_path);
#line 29 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		self->priv->_file_path = _tmp0_;
#line 29 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		g_object_notify_by_pspec ((GObject *) self, trash_applet_widgets_trash_item_properties[TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_PATH_PROPERTY]);
#line 880 "TrashItem.c"
	}
}

const gchar*
trash_applet_widgets_trash_item_get_file_name (TrashAppletWidgetsTrashItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp0_ = self->priv->_file_name;
#line 30 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	result = _tmp0_;
#line 30 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	return result;
#line 897 "TrashItem.c"
}

static void
trash_applet_widgets_trash_item_set_file_name (TrashAppletWidgetsTrashItem* self,
                                               const gchar* value)
{
	gchar* old_value;
#line 30 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_return_if_fail (self != NULL);
#line 30 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	old_value = trash_applet_widgets_trash_item_get_file_name (self);
#line 30 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 911 "TrashItem.c"
		gchar* _tmp0_;
#line 30 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		_tmp0_ = g_strdup (value);
#line 30 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		_g_free0 (self->priv->_file_name);
#line 30 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		self->priv->_file_name = _tmp0_;
#line 30 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		g_object_notify_by_pspec ((GObject *) self, trash_applet_widgets_trash_item_properties[TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_NAME_PROPERTY]);
#line 921 "TrashItem.c"
	}
}

gboolean
trash_applet_widgets_trash_item_get_is_directory (TrashAppletWidgetsTrashItem* self)
{
	gboolean result;
#line 31 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	result = self->priv->_is_directory;
#line 31 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	return result;
#line 935 "TrashItem.c"
}

static void
trash_applet_widgets_trash_item_set_is_directory (TrashAppletWidgetsTrashItem* self,
                                                  gboolean value)
{
	gboolean old_value;
#line 31 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_return_if_fail (self != NULL);
#line 31 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	old_value = trash_applet_widgets_trash_item_get_is_directory (self);
#line 31 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	if (old_value != value) {
#line 31 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		self->priv->_is_directory = value;
#line 31 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		g_object_notify_by_pspec ((GObject *) self, trash_applet_widgets_trash_item_properties[TRASH_APPLET_WIDGETS_TRASH_ITEM_IS_DIRECTORY_PROPERTY]);
#line 953 "TrashItem.c"
	}
}

GDateTime*
trash_applet_widgets_trash_item_get_deletion_time (TrashAppletWidgetsTrashItem* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 32 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_tmp0_ = self->priv->_deletion_time;
#line 32 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	result = _tmp0_;
#line 32 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	return result;
#line 970 "TrashItem.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 32 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 978 "TrashItem.c"
}

static void
trash_applet_widgets_trash_item_set_deletion_time (TrashAppletWidgetsTrashItem* self,
                                                   GDateTime* value)
{
	GDateTime* old_value;
#line 32 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_return_if_fail (self != NULL);
#line 32 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	old_value = trash_applet_widgets_trash_item_get_deletion_time (self);
#line 32 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	if (old_value != value) {
#line 992 "TrashItem.c"
		GDateTime* _tmp0_;
#line 32 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 32 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		_g_date_time_unref0 (self->priv->_deletion_time);
#line 32 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		self->priv->_deletion_time = _tmp0_;
#line 32 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		g_object_notify_by_pspec ((GObject *) self, trash_applet_widgets_trash_item_properties[TRASH_APPLET_WIDGETS_TRASH_ITEM_DELETION_TIME_PROPERTY]);
#line 1002 "TrashItem.c"
	}
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_return_if_fail (n_param_values == 3);
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		data1 = closure->data;
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		data2 = param_values->data[0].v_pointer;
#line 1028 "TrashItem.c"
	} else {
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		data1 = param_values->data[0].v_pointer;
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		data2 = closure->data;
#line 1034 "TrashItem.c"
	}
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), data2);
#line 1040 "TrashItem.c"
}

static void
trash_applet_widgets_trash_item_class_init (TrashAppletWidgetsTrashItemClass * klass,
                                            gpointer klass_data)
{
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	trash_applet_widgets_trash_item_parent_class = g_type_class_peek_parent (klass);
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_type_class_adjust_private_offset (klass, &TrashAppletWidgetsTrashItem_private_offset);
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_trash_applet_widgets_trash_item_get_property;
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_trash_applet_widgets_trash_item_set_property;
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	G_OBJECT_CLASS (klass)->finalize = trash_applet_widgets_trash_item_finalize;
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_PATH_PROPERTY, trash_applet_widgets_trash_item_properties[TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_PATH_PROPERTY] = g_param_spec_string ("file-path", "file-path", "file-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_NAME_PROPERTY, trash_applet_widgets_trash_item_properties[TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_NAME_PROPERTY] = g_param_spec_string ("file-name", "file-name", "file-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRASH_APPLET_WIDGETS_TRASH_ITEM_IS_DIRECTORY_PROPERTY, trash_applet_widgets_trash_item_properties[TRASH_APPLET_WIDGETS_TRASH_ITEM_IS_DIRECTORY_PROPERTY] = g_param_spec_boolean ("is-directory", "is-directory", "is-directory", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRASH_APPLET_WIDGETS_TRASH_ITEM_DELETION_TIME_PROPERTY, trash_applet_widgets_trash_item_properties[TRASH_APPLET_WIDGETS_TRASH_ITEM_DELETION_TIME_PROPERTY] = g_param_spec_boxed ("deletion-time", "deletion-time", "deletion-time", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	trash_applet_widgets_trash_item_signals[TRASH_APPLET_WIDGETS_TRASH_ITEM_ON_DELETE_SIGNAL] = g_signal_new ("on-delete", TRASH_APPLET_WIDGETS_TYPE_TRASH_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	trash_applet_widgets_trash_item_signals[TRASH_APPLET_WIDGETS_TRASH_ITEM_ON_RESTORE_SIGNAL] = g_signal_new ("on-restore", TRASH_APPLET_WIDGETS_TYPE_TRASH_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
#line 1069 "TrashItem.c"
}

static void
trash_applet_widgets_trash_item_instance_init (TrashAppletWidgetsTrashItem * self,
                                               gpointer klass)
{
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv = trash_applet_widgets_trash_item_get_instance_private (self);
#line 27 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->restoring = FALSE;
#line 35 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->file_container = NULL;
#line 36 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->file_icon = NULL;
#line 37 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->display_text = NULL;
#line 38 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->restore_button = NULL;
#line 39 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->delete_button = NULL;
#line 41 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->info_revealer = NULL;
#line 42 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->info_container = NULL;
#line 43 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->path_label = NULL;
#line 44 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->date_label = NULL;
#line 46 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->revealer = NULL;
#line 47 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->revealer_container = NULL;
#line 48 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->revealer_text = NULL;
#line 49 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->revealer_buttons = NULL;
#line 50 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->go_back_button = NULL;
#line 51 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self->priv->confirm_button = NULL;
#line 1110 "TrashItem.c"
}

static void
trash_applet_widgets_trash_item_finalize (GObject * obj)
{
	TrashAppletWidgetsTrashItem * self;
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TRASH_APPLET_WIDGETS_TYPE_TRASH_ITEM, TrashAppletWidgetsTrashItem);
#line 29 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_free0 (self->priv->_file_path);
#line 30 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_free0 (self->priv->_file_name);
#line 32 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_date_time_unref0 (self->priv->_deletion_time);
#line 35 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->file_container);
#line 36 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->file_icon);
#line 37 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->display_text);
#line 38 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->restore_button);
#line 39 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->delete_button);
#line 41 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->info_revealer);
#line 42 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->info_container);
#line 43 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->path_label);
#line 44 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->date_label);
#line 46 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->revealer);
#line 47 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->revealer_container);
#line 48 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->revealer_text);
#line 49 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->revealer_buttons);
#line 50 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->go_back_button);
#line 51 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	_g_object_unref0 (self->priv->confirm_button);
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	G_OBJECT_CLASS (trash_applet_widgets_trash_item_parent_class)->finalize (obj);
#line 1157 "TrashItem.c"
}

GType
trash_applet_widgets_trash_item_get_type (void)
{
	return trash_applet_widgets_trash_item_type_id;
}

GType
trash_applet_widgets_trash_item_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (TrashAppletWidgetsTrashItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) trash_applet_widgets_trash_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TrashAppletWidgetsTrashItem), 0, (GInstanceInitFunc) trash_applet_widgets_trash_item_instance_init, NULL };
	trash_applet_widgets_trash_item_type_id = g_type_module_register_type (module, gtk_box_get_type (), "TrashAppletWidgetsTrashItem", &g_define_type_info, 0);
	TrashAppletWidgetsTrashItem_private_offset = sizeof (TrashAppletWidgetsTrashItemPrivate);
	return trash_applet_widgets_trash_item_type_id;
}

static void
_vala_trash_applet_widgets_trash_item_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec)
{
	TrashAppletWidgetsTrashItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TRASH_APPLET_WIDGETS_TYPE_TRASH_ITEM, TrashAppletWidgetsTrashItem);
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	switch (property_id) {
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		case TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_PATH_PROPERTY:
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		g_value_set_string (value, trash_applet_widgets_trash_item_get_file_path (self));
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		break;
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		case TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_NAME_PROPERTY:
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		g_value_set_string (value, trash_applet_widgets_trash_item_get_file_name (self));
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		break;
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		case TRASH_APPLET_WIDGETS_TRASH_ITEM_IS_DIRECTORY_PROPERTY:
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		g_value_set_boolean (value, trash_applet_widgets_trash_item_get_is_directory (self));
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		break;
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		case TRASH_APPLET_WIDGETS_TRASH_ITEM_DELETION_TIME_PROPERTY:
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		g_value_set_boxed (value, trash_applet_widgets_trash_item_get_deletion_time (self));
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		break;
#line 1209 "TrashItem.c"
		default:
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		break;
#line 1215 "TrashItem.c"
	}
}

static void
_vala_trash_applet_widgets_trash_item_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec)
{
	TrashAppletWidgetsTrashItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TRASH_APPLET_WIDGETS_TYPE_TRASH_ITEM, TrashAppletWidgetsTrashItem);
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
	switch (property_id) {
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		case TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_PATH_PROPERTY:
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		trash_applet_widgets_trash_item_set_file_path (self, g_value_get_string (value));
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		break;
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		case TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_NAME_PROPERTY:
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		trash_applet_widgets_trash_item_set_file_name (self, g_value_get_string (value));
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		break;
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		case TRASH_APPLET_WIDGETS_TRASH_ITEM_IS_DIRECTORY_PROPERTY:
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		trash_applet_widgets_trash_item_set_is_directory (self, g_value_get_boolean (value));
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		break;
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		case TRASH_APPLET_WIDGETS_TRASH_ITEM_DELETION_TIME_PROPERTY:
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		trash_applet_widgets_trash_item_set_deletion_time (self, g_value_get_boxed (value));
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		break;
#line 1253 "TrashItem.c"
		default:
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../budgie-trash/trash/src/Widgets/TrashItem.vala"
		break;
#line 1259 "TrashItem.c"
	}
}

