/* TrashStoreWidget.c generated by valac 0.56.8, the Vala compiler
 * generated from TrashStoreWidget.vala, do not modify */

/*
 * This file is part of UbuntuBudgie
 *
 * Copyright 2019 Evan Maddock, 2021 Ubuntu Budgie Developers
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "trashapplet.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>

enum  {
	TRASH_APPLET_WIDGETS_TRASH_STORE_WIDGET_0_PROPERTY,
	TRASH_APPLET_WIDGETS_TRASH_STORE_WIDGET_NUM_PROPERTIES
};
static GParamSpec* trash_applet_widgets_trash_store_widget_properties[TRASH_APPLET_WIDGETS_TRASH_STORE_WIDGET_NUM_PROPERTIES];
#define _trash_applet_trash_store_unref0(var) ((var == NULL) ? NULL : (var = (trash_applet_trash_store_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _TrashAppletWidgetsTrashStoreWidgetPrivate {
	TrashAppletTrashStore* trash_store;
	GHashTable* trash_items;
	gboolean restoring;
	GtkBox* store_header;
	GtkImage* drive_icon;
	GtkLabel* store_label;
	GtkButton* restore_button;
	GtkButton* delete_button;
	GtkRevealer* revealer;
	GtkBox* revealer_container;
	GtkLabel* revealer_text;
	GtkBox* revealer_buttons;
	GtkButton* go_back_button;
	GtkButton* confirm_button;
	GtkListBox* file_box;
};

static gint TrashAppletWidgetsTrashStoreWidget_private_offset;
static gpointer trash_applet_widgets_trash_store_widget_parent_class = NULL;
static GType trash_applet_widgets_trash_store_widget_type_id = 0;

static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void trash_applet_widgets_trash_store_widget_set_buttons_sensitive (TrashAppletWidgetsTrashStoreWidget* self,
                                                                    gboolean is_sensitive);
static void trash_applet_widgets_trash_store_widget_apply_button_styles (TrashAppletWidgetsTrashStoreWidget* self);
static void trash_applet_widgets_trash_store_widget_connect_signals (TrashAppletWidgetsTrashStoreWidget* self);
static void __lambda11_ (TrashAppletWidgetsTrashStoreWidget* self,
                  const gchar* file_name);
static void ___lambda11__trash_applet_widgets_trash_item_on_delete (TrashAppletWidgetsTrashItem* _sender,
                                                             const gchar* file_name,
                                                             gpointer self);
static void __lambda12_ (TrashAppletWidgetsTrashStoreWidget* self,
                  const gchar* file_name,
                  const gchar* restore_path);
static void ___lambda12__trash_applet_widgets_trash_item_on_restore (TrashAppletWidgetsTrashItem* _sender,
                                                              const gchar* file_name,
                                                              const gchar* restore_path,
                                                              gpointer self);
static gint trash_applet_widgets_trash_store_widget_sort_by_type (TrashAppletWidgetsTrashStoreWidget* self,
                                                           GtkListBoxRow* row1,
                                                           GtkListBoxRow* row2);
static gint _trash_applet_widgets_trash_store_widget_sort_by_type_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                                   GtkListBoxRow* row2,
                                                                                   gpointer self);
static gint trash_applet_widgets_trash_store_widget_sort_by_name (TrashAppletWidgetsTrashStoreWidget* self,
                                                           GtkListBoxRow* row1,
                                                           GtkListBoxRow* row2);
static gint _trash_applet_widgets_trash_store_widget_sort_by_name_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                                   GtkListBoxRow* row2,
                                                                                   gpointer self);
static gint trash_applet_widgets_trash_store_widget_sort_by_newest (TrashAppletWidgetsTrashStoreWidget* self,
                                                             GtkListBoxRow* row1,
                                                             GtkListBoxRow* row2);
static gint _trash_applet_widgets_trash_store_widget_sort_by_newest_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                                     GtkListBoxRow* row2,
                                                                                     gpointer self);
static gint trash_applet_widgets_trash_store_widget_sort_by_oldest (TrashAppletWidgetsTrashStoreWidget* self,
                                                             GtkListBoxRow* row1,
                                                             GtkListBoxRow* row2);
static gint _trash_applet_widgets_trash_store_widget_sort_by_oldest_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                                     GtkListBoxRow* row2,
                                                                                     gpointer self);
static gint trash_applet_widgets_trash_store_widget_sort_by_name_reverse (TrashAppletWidgetsTrashStoreWidget* self,
                                                                   GtkListBoxRow* row1,
                                                                   GtkListBoxRow* row2);
static gint _trash_applet_widgets_trash_store_widget_sort_by_name_reverse_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                                           GtkListBoxRow* row2,
                                                                                           gpointer self);
static void _trash_applet_widgets_trash_store_widget_add_trash_item_trash_applet_trash_store_trash_added (TrashAppletTrashStore* _sender,
                                                                                                   const gchar* file_name,
                                                                                                   const gchar* file_path,
                                                                                                   GIcon* file_icon,
                                                                                                   GDateTime* deletion_time,
                                                                                                   gboolean is_directory,
                                                                                                   gpointer self);
static void _trash_applet_widgets_trash_store_widget_remove_trash_item_trash_applet_trash_store_trash_removed (TrashAppletTrashStore* _sender,
                                                                                                        const gchar* file_name,
                                                                                                        gboolean is_empty,
                                                                                                        gpointer self);
static void __lambda13_ (TrashAppletWidgetsTrashStoreWidget* self);
static void trash_applet_widgets_trash_store_widget_show_confirmation (TrashAppletWidgetsTrashStoreWidget* self,
                                                                gboolean restore);
static void ___lambda13__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda14_ (TrashAppletWidgetsTrashStoreWidget* self);
static void ___lambda14__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda15_ (TrashAppletWidgetsTrashStoreWidget* self);
static void ___lambda16_ (TrashAppletWidgetsTrashStoreWidget* self,
                   TrashAppletWidgetsTrashItem* item);
static void ____lambda16__gfunc (gconstpointer data,
                          gpointer self);
static void ___lambda17_ (TrashAppletWidgetsTrashStoreWidget* self,
                   TrashAppletWidgetsTrashItem* item);
static void ____lambda17__gfunc (gconstpointer data,
                          gpointer self);
static void ___lambda15__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda18_ (TrashAppletWidgetsTrashStoreWidget* self);
static void ___lambda18__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda19_ (TrashAppletWidgetsTrashStoreWidget* self,
                  GtkListBoxRow* row);
static void ___lambda19__gtk_list_box_row_activated (GtkListBox* _sender,
                                              GtkListBoxRow* row,
                                              gpointer self);
static void trash_applet_widgets_trash_store_widget_finalize (GObject * obj);

static inline gpointer
trash_applet_widgets_trash_store_widget_get_instance_private (TrashAppletWidgetsTrashStoreWidget* self)
{
	return G_STRUCT_MEMBER_P (self, TrashAppletWidgetsTrashStoreWidget_private_offset);
}

static gpointer
_trash_applet_trash_store_ref0 (gpointer self)
{
#line 47 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	return self ? trash_applet_trash_store_ref (self) : NULL;
#line 164 "TrashStoreWidget.c"
}

static void
_g_free0_ (gpointer var)
{
#line 48 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	var = (g_free (var), NULL);
#line 172 "TrashStoreWidget.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 48 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 180 "TrashStoreWidget.c"
}

TrashAppletWidgetsTrashStoreWidget*
trash_applet_widgets_trash_store_widget_construct (GType object_type,
                                                   TrashAppletTrashStore* trash_store,
                                                   TrashAppletWidgetsSortType sort_type)
{
	TrashAppletWidgetsTrashStoreWidget * self = NULL;
	TrashAppletTrashStore* _tmp0_;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GHashTable* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkBox* _tmp8_;
	GtkBox* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GIcon* _tmp12_;
	GIcon* _tmp13_;
	GtkImage* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkBox* _tmp22_;
	GtkImage* _tmp23_;
	GtkBox* _tmp24_;
	GtkLabel* _tmp25_;
	GtkButton* _tmp26_;
	GtkButton* _tmp27_;
	GtkButton* _tmp28_;
	GtkButton* _tmp29_;
	GtkBox* _tmp30_;
	GtkButton* _tmp31_;
	GtkBox* _tmp32_;
	GtkButton* _tmp33_;
	GtkRevealer* _tmp34_;
	GtkRevealer* _tmp35_;
	GtkRevealer* _tmp36_;
	GtkBox* _tmp37_;
	GtkLabel* _tmp38_;
	GtkLabel* _tmp39_;
	GtkBox* _tmp40_;
	GtkButton* _tmp41_;
	GtkButton* _tmp42_;
	GtkBox* _tmp43_;
	GtkButton* _tmp44_;
	GtkBox* _tmp45_;
	GtkButton* _tmp46_;
	GtkBox* _tmp47_;
	GtkLabel* _tmp48_;
	GtkBox* _tmp49_;
	GtkBox* _tmp50_;
	GtkRevealer* _tmp51_;
	GtkBox* _tmp52_;
	GtkListBox* _tmp53_;
	GtkListBox* _tmp54_;
	GtkStyleContext* _tmp55_;
	GtkListBox* _tmp56_;
	GtkStyleContext* _tmp57_;
	GtkListBox* _tmp58_;
	GtkListBox* _tmp59_;
	GtkBox* _tmp60_;
	GtkRevealer* _tmp61_;
	GtkListBox* _tmp62_;
#line 45 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_val_if_fail (trash_store != NULL, NULL);
#line 46 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self = (TrashAppletWidgetsTrashStoreWidget*) g_object_new (object_type, "orientation", GTK_ORIENTATION_VERTICAL, "spacing", 0, NULL);
#line 47 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp0_ = _trash_applet_trash_store_ref0 (trash_store);
#line 47 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_trash_applet_trash_store_unref0 (self->priv->trash_store);
#line 47 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->trash_store = _tmp0_;
#line 48 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp1_ = g_str_hash;
#line 48 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp2_ = g_str_equal;
#line 48 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, _g_object_unref0_);
#line 48 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_hash_table_unref0 (self->priv->trash_items);
#line 48 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->trash_items = _tmp3_;
#line 49 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 49 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_style_context_add_class (_tmp4_, "trash-store-widget");
#line 52 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 52 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_object_ref_sink (_tmp5_);
#line 52 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->store_header);
#line 52 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->store_header = _tmp5_;
#line 53 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp6_ = self->priv->store_header;
#line 53 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
#line 53 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_style_context_add_class (_tmp7_, "trash-store-header");
#line 54 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp8_ = self->priv->store_header;
#line 54 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_object_set ((GtkWidget*) _tmp8_, "height-request", 32, NULL);
#line 55 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp9_ = self->priv->store_header;
#line 55 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp10_ = trash_applet_trash_store_get_drive_name (trash_store);
#line 55 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp11_ = _tmp10_;
#line 55 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp9_, _tmp11_);
#line 55 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_free0 (_tmp11_);
#line 56 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp12_ = trash_applet_trash_store_get_drive_icon (trash_store);
#line 56 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp13_ = _tmp12_;
#line 56 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp14_ = (GtkImage*) gtk_image_new_from_gicon (_tmp13_, (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 56 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_object_ref_sink (_tmp14_);
#line 56 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->drive_icon);
#line 56 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->drive_icon = _tmp14_;
#line 56 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (_tmp13_);
#line 57 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp15_ = trash_applet_trash_store_get_drive_name (trash_store);
#line 57 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp16_ = _tmp15_;
#line 57 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp17_ = (GtkLabel*) gtk_label_new (_tmp16_);
#line 57 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_object_ref_sink (_tmp17_);
#line 57 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->store_label);
#line 57 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->store_label = _tmp17_;
#line 57 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_free0 (_tmp16_);
#line 58 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp18_ = self->priv->store_label;
#line 58 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_label_set_max_width_chars (_tmp18_, 30);
#line 59 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp19_ = self->priv->store_label;
#line 59 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_label_set_ellipsize (_tmp19_, PANGO_ELLIPSIZE_END);
#line 60 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp20_ = self->priv->store_label;
#line 60 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp20_, GTK_ALIGN_START);
#line 61 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp21_ = self->priv->store_label;
#line 61 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_label_set_justify (_tmp21_, GTK_JUSTIFY_LEFT);
#line 62 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp22_ = self->priv->store_header;
#line 62 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp23_ = self->priv->drive_icon;
#line 62 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_box_pack_start (_tmp22_, (GtkWidget*) _tmp23_, FALSE, FALSE, (guint) 10);
#line 63 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp24_ = self->priv->store_header;
#line 63 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp25_ = self->priv->store_label;
#line 63 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_box_pack_start (_tmp24_, (GtkWidget*) _tmp25_, TRUE, TRUE, (guint) 0);
#line 65 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp26_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-undo-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 65 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_object_ref_sink (_tmp26_);
#line 65 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->restore_button);
#line 65 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->restore_button = _tmp26_;
#line 66 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp27_ = self->priv->restore_button;
#line 66 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp27_, _ ("Restore all items"));
#line 67 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp28_ = (GtkButton*) gtk_button_new_from_icon_name ("list-remove-all-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 67 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_object_ref_sink (_tmp28_);
#line 67 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->delete_button);
#line 67 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->delete_button = _tmp28_;
#line 68 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp29_ = self->priv->delete_button;
#line 68 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp29_, _ ("Delete all items"));
#line 69 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_applet_widgets_trash_store_widget_set_buttons_sensitive (self, FALSE);
#line 70 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp30_ = self->priv->store_header;
#line 70 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp31_ = self->priv->delete_button;
#line 70 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_box_pack_end (_tmp30_, (GtkWidget*) _tmp31_, FALSE, FALSE, (guint) 0);
#line 71 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp32_ = self->priv->store_header;
#line 71 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp33_ = self->priv->restore_button;
#line 71 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_box_pack_end (_tmp32_, (GtkWidget*) _tmp33_, FALSE, FALSE, (guint) 0);
#line 73 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp34_ = (GtkRevealer*) gtk_revealer_new ();
#line 73 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_object_ref_sink (_tmp34_);
#line 73 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->revealer);
#line 73 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->revealer = _tmp34_;
#line 74 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp35_ = self->priv->revealer;
#line 74 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_revealer_set_transition_type (_tmp35_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
#line 75 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp36_ = self->priv->revealer;
#line 75 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_revealer_set_reveal_child (_tmp36_, FALSE);
#line 76 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp37_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 5);
#line 76 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_object_ref_sink (_tmp37_);
#line 76 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->revealer_container);
#line 76 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->revealer_container = _tmp37_;
#line 77 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp38_ = (GtkLabel*) gtk_label_new ("");
#line 77 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_object_ref_sink (_tmp38_);
#line 77 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->revealer_text);
#line 77 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->revealer_text = _tmp38_;
#line 78 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp39_ = self->priv->revealer_text;
#line 78 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_object_set ((GtkWidget*) _tmp39_, "height-request", 20, NULL);
#line 80 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp40_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 80 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_object_ref_sink (_tmp40_);
#line 80 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->revealer_buttons);
#line 80 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->revealer_buttons = _tmp40_;
#line 81 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp41_ = (GtkButton*) gtk_button_new_with_label (_ ("No"));
#line 81 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_object_ref_sink (_tmp41_);
#line 81 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->go_back_button);
#line 81 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->go_back_button = _tmp41_;
#line 82 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp42_ = (GtkButton*) gtk_button_new_with_label (_ ("Yes"));
#line 82 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_object_ref_sink (_tmp42_);
#line 82 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->confirm_button);
#line 82 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->confirm_button = _tmp42_;
#line 83 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp43_ = self->priv->revealer_buttons;
#line 83 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp44_ = self->priv->go_back_button;
#line 83 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_box_pack_start (_tmp43_, (GtkWidget*) _tmp44_, TRUE, TRUE, (guint) 0);
#line 84 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp45_ = self->priv->revealer_buttons;
#line 84 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp46_ = self->priv->confirm_button;
#line 84 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_box_pack_end (_tmp45_, (GtkWidget*) _tmp46_, TRUE, TRUE, (guint) 0);
#line 86 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp47_ = self->priv->revealer_container;
#line 86 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp48_ = self->priv->revealer_text;
#line 86 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_box_pack_start (_tmp47_, (GtkWidget*) _tmp48_, TRUE, TRUE, (guint) 0);
#line 87 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp49_ = self->priv->revealer_container;
#line 87 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp50_ = self->priv->revealer_buttons;
#line 87 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_box_pack_end (_tmp49_, (GtkWidget*) _tmp50_, TRUE, TRUE, (guint) 0);
#line 88 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp51_ = self->priv->revealer;
#line 88 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp52_ = self->priv->revealer_container;
#line 88 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_container_add ((GtkContainer*) _tmp51_, (GtkWidget*) _tmp52_);
#line 90 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp53_ = (GtkListBox*) gtk_list_box_new ();
#line 90 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_object_ref_sink (_tmp53_);
#line 90 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->file_box);
#line 90 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->file_box = _tmp53_;
#line 91 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp54_ = self->priv->file_box;
#line 91 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp55_ = gtk_widget_get_style_context ((GtkWidget*) _tmp54_);
#line 91 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_style_context_add_class (_tmp55_, "trash-file-box");
#line 92 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp56_ = self->priv->file_box;
#line 92 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp57_ = gtk_widget_get_style_context ((GtkWidget*) _tmp56_);
#line 92 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_style_context_add_class (_tmp57_, "empty");
#line 93 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp58_ = self->priv->file_box;
#line 93 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_list_box_set_activate_on_single_click (_tmp58_, TRUE);
#line 94 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp59_ = self->priv->file_box;
#line 94 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_list_box_set_selection_mode (_tmp59_, GTK_SELECTION_NONE);
#line 95 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_applet_widgets_trash_store_widget_set_sort_type (self, sort_type);
#line 97 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_applet_widgets_trash_store_widget_apply_button_styles (self);
#line 98 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_applet_widgets_trash_store_widget_connect_signals (self);
#line 100 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp60_ = self->priv->store_header;
#line 100 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp60_, TRUE, TRUE, (guint) 0);
#line 101 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp61_ = self->priv->revealer;
#line 101 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp61_, FALSE, FALSE, (guint) 0);
#line 102 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp62_ = self->priv->file_box;
#line 102 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp62_, TRUE, TRUE, (guint) 0);
#line 103 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 45 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	return self;
#line 538 "TrashStoreWidget.c"
}

TrashAppletWidgetsTrashStoreWidget*
trash_applet_widgets_trash_store_widget_new (TrashAppletTrashStore* trash_store,
                                             TrashAppletWidgetsSortType sort_type)
{
#line 45 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	return trash_applet_widgets_trash_store_widget_construct (TRASH_APPLET_WIDGETS_TYPE_TRASH_STORE_WIDGET, trash_store, sort_type);
#line 547 "TrashStoreWidget.c"
}

/**
         * Add a new trash item.
         * 
         * @param info The FileInfo for the newly trashed file
         * @param old_path The path that the file came from
         */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 114 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	return self ? g_object_ref (self) : NULL;
#line 561 "TrashStoreWidget.c"
}

static void
__lambda11_ (TrashAppletWidgetsTrashStoreWidget* self,
             const gchar* file_name)
{
	TrashAppletTrashStore* _tmp0_;
#line 119 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_if_fail (file_name != NULL);
#line 120 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp0_ = self->priv->trash_store;
#line 120 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_applet_trash_store_delete_file (_tmp0_, file_name);
#line 575 "TrashStoreWidget.c"
}

static void
___lambda11__trash_applet_widgets_trash_item_on_delete (TrashAppletWidgetsTrashItem* _sender,
                                                        const gchar* file_name,
                                                        gpointer self)
{
#line 119 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	__lambda11_ ((TrashAppletWidgetsTrashStoreWidget*) self, file_name);
#line 585 "TrashStoreWidget.c"
}

static void
__lambda12_ (TrashAppletWidgetsTrashStoreWidget* self,
             const gchar* file_name,
             const gchar* restore_path)
{
	TrashAppletTrashStore* _tmp0_;
#line 123 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_if_fail (file_name != NULL);
#line 123 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_if_fail (restore_path != NULL);
#line 124 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp0_ = self->priv->trash_store;
#line 124 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_applet_trash_store_restore_file (_tmp0_, file_name, restore_path);
#line 602 "TrashStoreWidget.c"
}

static void
___lambda12__trash_applet_widgets_trash_item_on_restore (TrashAppletWidgetsTrashItem* _sender,
                                                         const gchar* file_name,
                                                         const gchar* restore_path,
                                                         gpointer self)
{
#line 123 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	__lambda12_ ((TrashAppletWidgetsTrashStoreWidget*) self, file_name, restore_path);
#line 613 "TrashStoreWidget.c"
}

void
trash_applet_widgets_trash_store_widget_add_trash_item (TrashAppletWidgetsTrashStoreWidget* self,
                                                        const gchar* file_name,
                                                        const gchar* file_path,
                                                        GIcon* file_icon,
                                                        GDateTime* deletion_time,
                                                        gboolean is_directory)
{
	TrashAppletWidgetsTrashItem* item = NULL;
	TrashAppletWidgetsTrashItem* _tmp0_;
	GHashTable* _tmp1_;
	gchar* _tmp2_;
	TrashAppletWidgetsTrashItem* _tmp3_;
	GtkListBox* _tmp4_;
	GtkListBox* _tmp5_;
	GtkStyleContext* _tmp6_;
#line 112 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_if_fail (self != NULL);
#line 112 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_if_fail (file_name != NULL);
#line 112 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_if_fail (file_path != NULL);
#line 112 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_if_fail (file_icon != NULL);
#line 112 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_if_fail (deletion_time != NULL);
#line 113 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp0_ = trash_applet_widgets_trash_item_new (file_path, file_name, file_icon, deletion_time, is_directory);
#line 113 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_object_ref_sink (_tmp0_);
#line 113 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	item = _tmp0_;
#line 114 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp1_ = self->priv->trash_items;
#line 114 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp2_ = g_strdup (file_name);
#line 114 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp3_ = _g_object_ref0 (item);
#line 114 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_hash_table_insert (_tmp1_, _tmp2_, _tmp3_);
#line 115 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp4_ = self->priv->file_box;
#line 115 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_list_box_insert (_tmp4_, (GtkWidget*) item, -1);
#line 116 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp5_ = self->priv->file_box;
#line 116 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
#line 116 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_style_context_remove_class (_tmp6_, "empty");
#line 117 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_applet_widgets_trash_store_widget_set_buttons_sensitive (self, TRUE);
#line 119 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_signal_connect_object (item, "on-delete", (GCallback) ___lambda11__trash_applet_widgets_trash_item_on_delete, self, 0);
#line 123 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_signal_connect_object (item, "on-restore", (GCallback) ___lambda12__trash_applet_widgets_trash_item_on_restore, self, 0);
#line 112 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (item);
#line 674 "TrashStoreWidget.c"
}

/**
         * Remove an item from the trash view.
         * 
         * @param file_name The name of the file to remove
         */
void
trash_applet_widgets_trash_store_widget_remove_trash_item (TrashAppletWidgetsTrashStoreWidget* self,
                                                           const gchar* file_name,
                                                           gboolean is_empty)
{
	TrashAppletWidgetsTrashItem* item = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	TrashAppletWidgetsTrashItem* _tmp2_;
	GtkListBox* _tmp3_;
	TrashAppletWidgetsTrashItem* _tmp4_;
	GtkContainer* _tmp5_;
	GHashTable* _tmp6_;
	GHashTable* _tmp7_;
#line 133 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_if_fail (self != NULL);
#line 133 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_if_fail (file_name != NULL);
#line 134 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp0_ = self->priv->trash_items;
#line 134 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, file_name);
#line 134 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp2_ = _g_object_ref0 ((TrashAppletWidgetsTrashItem*) _tmp1_);
#line 134 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	item = _tmp2_;
#line 135 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp3_ = self->priv->file_box;
#line 135 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp4_ = item;
#line 135 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp5_ = gtk_widget_get_parent ((GtkWidget*) _tmp4_);
#line 135 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_container_remove ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp5_);
#line 136 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp6_ = self->priv->trash_items;
#line 136 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_hash_table_remove (_tmp6_, file_name);
#line 139 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp7_ = self->priv->trash_items;
#line 139 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	if (g_hash_table_size (_tmp7_) == ((guint) 0)) {
#line 724 "TrashStoreWidget.c"
		GtkListBox* _tmp8_;
		GtkStyleContext* _tmp9_;
#line 140 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp8_ = self->priv->file_box;
#line 140 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
#line 140 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		gtk_style_context_add_class (_tmp9_, "empty");
#line 141 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		trash_applet_widgets_trash_store_widget_set_buttons_sensitive (self, FALSE);
#line 735 "TrashStoreWidget.c"
	}
#line 133 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (item);
#line 739 "TrashStoreWidget.c"
}

gchar*
trash_applet_widgets_trash_store_widget_get_name (TrashAppletWidgetsTrashStoreWidget* self)
{
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 145 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 146 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp0_ = self->priv->store_label;
#line 146 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp1_ = gtk_label_get_label (_tmp0_);
#line 146 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 146 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	result = _tmp2_;
#line 146 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	return result;
#line 761 "TrashStoreWidget.c"
}

static gint
_trash_applet_widgets_trash_store_widget_sort_by_type_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                              GtkListBoxRow* row2,
                                                                              gpointer self)
{
	gint result;
	result = trash_applet_widgets_trash_store_widget_sort_by_type ((TrashAppletWidgetsTrashStoreWidget*) self, row1, row2);
#line 152 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	return result;
#line 773 "TrashStoreWidget.c"
}

static gint
_trash_applet_widgets_trash_store_widget_sort_by_name_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                              GtkListBoxRow* row2,
                                                                              gpointer self)
{
	gint result;
	result = trash_applet_widgets_trash_store_widget_sort_by_name ((TrashAppletWidgetsTrashStoreWidget*) self, row1, row2);
#line 155 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	return result;
#line 785 "TrashStoreWidget.c"
}

static gint
_trash_applet_widgets_trash_store_widget_sort_by_newest_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                                GtkListBoxRow* row2,
                                                                                gpointer self)
{
	gint result;
	result = trash_applet_widgets_trash_store_widget_sort_by_newest ((TrashAppletWidgetsTrashStoreWidget*) self, row1, row2);
#line 158 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	return result;
#line 797 "TrashStoreWidget.c"
}

static gint
_trash_applet_widgets_trash_store_widget_sort_by_oldest_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                                GtkListBoxRow* row2,
                                                                                gpointer self)
{
	gint result;
	result = trash_applet_widgets_trash_store_widget_sort_by_oldest ((TrashAppletWidgetsTrashStoreWidget*) self, row1, row2);
#line 161 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	return result;
#line 809 "TrashStoreWidget.c"
}

static gint
_trash_applet_widgets_trash_store_widget_sort_by_name_reverse_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                                      GtkListBoxRow* row2,
                                                                                      gpointer self)
{
	gint result;
	result = trash_applet_widgets_trash_store_widget_sort_by_name_reverse ((TrashAppletWidgetsTrashStoreWidget*) self, row1, row2);
#line 164 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	return result;
#line 821 "TrashStoreWidget.c"
}

void
trash_applet_widgets_trash_store_widget_set_sort_type (TrashAppletWidgetsTrashStoreWidget* self,
                                                       TrashAppletWidgetsSortType type)
{
#line 149 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_if_fail (self != NULL);
#line 150 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	switch (type) {
#line 150 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		case TRASH_APPLET_WIDGETS_SORT_TYPE_TYPE:
#line 834 "TrashStoreWidget.c"
		{
			GtkListBox* _tmp0_;
#line 152 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			_tmp0_ = self->priv->file_box;
#line 152 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			gtk_list_box_set_sort_func (_tmp0_, _trash_applet_widgets_trash_store_widget_sort_by_type_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
#line 153 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			break;
#line 843 "TrashStoreWidget.c"
		}
#line 150 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		case TRASH_APPLET_WIDGETS_SORT_TYPE_ALPHABETICAL:
#line 847 "TrashStoreWidget.c"
		{
			GtkListBox* _tmp1_;
#line 155 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			_tmp1_ = self->priv->file_box;
#line 155 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			gtk_list_box_set_sort_func (_tmp1_, _trash_applet_widgets_trash_store_widget_sort_by_name_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
#line 156 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			break;
#line 856 "TrashStoreWidget.c"
		}
#line 150 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		case TRASH_APPLET_WIDGETS_SORT_TYPE_NEWEST_FIRST:
#line 860 "TrashStoreWidget.c"
		{
			GtkListBox* _tmp2_;
#line 158 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			_tmp2_ = self->priv->file_box;
#line 158 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			gtk_list_box_set_sort_func (_tmp2_, _trash_applet_widgets_trash_store_widget_sort_by_newest_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
#line 159 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			break;
#line 869 "TrashStoreWidget.c"
		}
#line 150 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		case TRASH_APPLET_WIDGETS_SORT_TYPE_OLDEST_FIRST:
#line 873 "TrashStoreWidget.c"
		{
			GtkListBox* _tmp3_;
#line 161 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			_tmp3_ = self->priv->file_box;
#line 161 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			gtk_list_box_set_sort_func (_tmp3_, _trash_applet_widgets_trash_store_widget_sort_by_oldest_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
#line 162 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			break;
#line 882 "TrashStoreWidget.c"
		}
#line 150 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		case TRASH_APPLET_WIDGETS_SORT_TYPE_REVERSE_ALPHABETICAL:
#line 886 "TrashStoreWidget.c"
		{
			GtkListBox* _tmp4_;
#line 164 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			_tmp4_ = self->priv->file_box;
#line 164 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			gtk_list_box_set_sort_func (_tmp4_, _trash_applet_widgets_trash_store_widget_sort_by_name_reverse_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
#line 165 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			break;
#line 895 "TrashStoreWidget.c"
		}
		default:
#line 150 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		break;
#line 900 "TrashStoreWidget.c"
	}
}

static void
trash_applet_widgets_trash_store_widget_apply_button_styles (TrashAppletWidgetsTrashStoreWidget* self)
{
	GtkButton* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkButton* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkButton* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkButton* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkButton* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkButton* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkButton* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkButton* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkButton* _tmp16_;
	GtkStyleContext* _tmp17_;
#line 169 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_if_fail (self != NULL);
#line 170 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp0_ = self->priv->restore_button;
#line 170 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) _tmp0_);
#line 170 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_style_context_add_class (_tmp1_, "flat");
#line 171 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp2_ = self->priv->delete_button;
#line 171 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
#line 171 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_style_context_add_class (_tmp3_, "flat");
#line 172 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp4_ = self->priv->go_back_button;
#line 172 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 172 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_style_context_add_class (_tmp5_, "flat");
#line 173 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp6_ = self->priv->confirm_button;
#line 173 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
#line 173 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_style_context_add_class (_tmp7_, "flat");
#line 174 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp8_ = self->priv->confirm_button;
#line 174 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
#line 174 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_style_context_add_class (_tmp9_, "destructive-action");
#line 176 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp10_ = self->priv->restore_button;
#line 176 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
#line 176 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_style_context_remove_class (_tmp11_, "button");
#line 177 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp12_ = self->priv->delete_button;
#line 177 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) _tmp12_);
#line 177 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_style_context_remove_class (_tmp13_, "button");
#line 178 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp14_ = self->priv->go_back_button;
#line 178 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
#line 178 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_style_context_remove_class (_tmp15_, "button");
#line 179 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp16_ = self->priv->confirm_button;
#line 179 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp17_ = gtk_widget_get_style_context ((GtkWidget*) _tmp16_);
#line 179 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_style_context_remove_class (_tmp17_, "button");
#line 981 "TrashStoreWidget.c"
}

static void
_trash_applet_widgets_trash_store_widget_add_trash_item_trash_applet_trash_store_trash_added (TrashAppletTrashStore* _sender,
                                                                                              const gchar* file_name,
                                                                                              const gchar* file_path,
                                                                                              GIcon* file_icon,
                                                                                              GDateTime* deletion_time,
                                                                                              gboolean is_directory,
                                                                                              gpointer self)
{
#line 183 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_applet_widgets_trash_store_widget_add_trash_item ((TrashAppletWidgetsTrashStoreWidget*) self, file_name, file_path, file_icon, deletion_time, is_directory);
#line 995 "TrashStoreWidget.c"
}

static void
_trash_applet_widgets_trash_store_widget_remove_trash_item_trash_applet_trash_store_trash_removed (TrashAppletTrashStore* _sender,
                                                                                                   const gchar* file_name,
                                                                                                   gboolean is_empty,
                                                                                                   gpointer self)
{
#line 184 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_applet_widgets_trash_store_widget_remove_trash_item ((TrashAppletWidgetsTrashStoreWidget*) self, file_name, is_empty);
#line 1006 "TrashStoreWidget.c"
}

static void
__lambda13_ (TrashAppletWidgetsTrashStoreWidget* self)
{
#line 187 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_applet_widgets_trash_store_widget_show_confirmation (self, FALSE);
#line 1014 "TrashStoreWidget.c"
}

static void
___lambda13__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 186 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	__lambda13_ ((TrashAppletWidgetsTrashStoreWidget*) self);
#line 1023 "TrashStoreWidget.c"
}

static void
__lambda14_ (TrashAppletWidgetsTrashStoreWidget* self)
{
#line 191 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_applet_widgets_trash_store_widget_show_confirmation (self, TRUE);
#line 1031 "TrashStoreWidget.c"
}

static void
___lambda14__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 190 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	__lambda14_ ((TrashAppletWidgetsTrashStoreWidget*) self);
#line 1040 "TrashStoreWidget.c"
}

static void
___lambda16_ (TrashAppletWidgetsTrashStoreWidget* self,
              TrashAppletWidgetsTrashItem* item)
{
	TrashAppletTrashStore* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
#line 196 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_if_fail (item != NULL);
#line 197 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp0_ = self->priv->trash_store;
#line 197 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp1_ = trash_applet_widgets_trash_item_get_file_name (item);
#line 197 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp2_ = _tmp1_;
#line 197 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp3_ = trash_applet_widgets_trash_item_get_file_path (item);
#line 197 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp4_ = _tmp3_;
#line 197 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_applet_trash_store_restore_file (_tmp0_, _tmp2_, _tmp4_);
#line 1066 "TrashStoreWidget.c"
}

static void
____lambda16__gfunc (gconstpointer data,
                     gpointer self)
{
#line 196 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	___lambda16_ ((TrashAppletWidgetsTrashStoreWidget*) self, (TrashAppletWidgetsTrashItem*) data);
#line 1075 "TrashStoreWidget.c"
}

static void
___lambda17_ (TrashAppletWidgetsTrashStoreWidget* self,
              TrashAppletWidgetsTrashItem* item)
{
	TrashAppletTrashStore* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 200 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_if_fail (item != NULL);
#line 201 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp0_ = self->priv->trash_store;
#line 201 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp1_ = trash_applet_widgets_trash_item_get_file_name (item);
#line 201 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp2_ = _tmp1_;
#line 201 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_applet_trash_store_delete_file (_tmp0_, _tmp2_);
#line 1095 "TrashStoreWidget.c"
}

static void
____lambda17__gfunc (gconstpointer data,
                     gpointer self)
{
#line 200 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	___lambda17_ ((TrashAppletWidgetsTrashStoreWidget*) self, (TrashAppletWidgetsTrashItem*) data);
#line 1104 "TrashStoreWidget.c"
}

static void
__lambda15_ (TrashAppletWidgetsTrashStoreWidget* self)
{
	GtkRevealer* _tmp6_;
#line 195 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	if (self->priv->restoring) {
#line 1113 "TrashStoreWidget.c"
		GHashTable* _tmp0_;
		GList* _tmp1_;
		GList* _tmp2_;
#line 196 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp0_ = self->priv->trash_items;
#line 196 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp1_ = g_hash_table_get_values (_tmp0_);
#line 196 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp2_ = _tmp1_;
#line 196 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		g_list_foreach (_tmp2_, ____lambda16__gfunc, self);
#line 196 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
#line 1127 "TrashStoreWidget.c"
	} else {
		GHashTable* _tmp3_;
		GList* _tmp4_;
		GList* _tmp5_;
#line 200 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp3_ = self->priv->trash_items;
#line 200 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp4_ = g_hash_table_get_values (_tmp3_);
#line 200 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp5_ = _tmp4_;
#line 200 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		g_list_foreach (_tmp5_, ____lambda17__gfunc, self);
#line 200 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		(_tmp5_ == NULL) ? NULL : (_tmp5_ = (g_list_free (_tmp5_), NULL));
#line 1142 "TrashStoreWidget.c"
	}
#line 205 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp6_ = self->priv->revealer;
#line 205 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_revealer_set_reveal_child (_tmp6_, FALSE);
#line 1148 "TrashStoreWidget.c"
}

static void
___lambda15__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 194 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	__lambda15_ ((TrashAppletWidgetsTrashStoreWidget*) self);
#line 1157 "TrashStoreWidget.c"
}

static void
__lambda18_ (TrashAppletWidgetsTrashStoreWidget* self)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkRevealer* _tmp2_;
#line 209 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp0_ = self->priv->restore_button;
#line 209 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
#line 210 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp1_ = self->priv->delete_button;
#line 210 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, TRUE);
#line 211 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp2_ = self->priv->revealer;
#line 211 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_revealer_set_reveal_child (_tmp2_, FALSE);
#line 1178 "TrashStoreWidget.c"
}

static void
___lambda18__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 208 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	__lambda18_ ((TrashAppletWidgetsTrashStoreWidget*) self);
#line 1187 "TrashStoreWidget.c"
}

static void
__lambda19_ (TrashAppletWidgetsTrashStoreWidget* self,
             GtkListBoxRow* row)
{
	TrashAppletWidgetsTrashItem* widget = NULL;
	GtkWidget* _tmp0_;
	TrashAppletWidgetsTrashItem* _tmp1_;
#line 214 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_if_fail (row != NULL);
#line 215 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) row);
#line 215 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TRASH_APPLET_WIDGETS_TYPE_TRASH_ITEM, TrashAppletWidgetsTrashItem));
#line 215 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	widget = _tmp1_;
#line 216 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_applet_widgets_trash_item_toggle_info_revealer (widget);
#line 214 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (widget);
#line 1209 "TrashStoreWidget.c"
}

static void
___lambda19__gtk_list_box_row_activated (GtkListBox* _sender,
                                         GtkListBoxRow* row,
                                         gpointer self)
{
#line 214 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	__lambda19_ ((TrashAppletWidgetsTrashStoreWidget*) self, row);
#line 1219 "TrashStoreWidget.c"
}

static void
trash_applet_widgets_trash_store_widget_connect_signals (TrashAppletWidgetsTrashStoreWidget* self)
{
	TrashAppletTrashStore* _tmp0_;
	TrashAppletTrashStore* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkListBox* _tmp6_;
#line 182 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_if_fail (self != NULL);
#line 183 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp0_ = self->priv->trash_store;
#line 183 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_signal_connect_object (_tmp0_, "trash-added", (GCallback) _trash_applet_widgets_trash_store_widget_add_trash_item_trash_applet_trash_store_trash_added, self, 0);
#line 184 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp1_ = self->priv->trash_store;
#line 184 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_signal_connect_object (_tmp1_, "trash-removed", (GCallback) _trash_applet_widgets_trash_store_widget_remove_trash_item_trash_applet_trash_store_trash_removed, self, 0);
#line 186 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp2_ = self->priv->delete_button;
#line 186 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_signal_connect_object (_tmp2_, "clicked", (GCallback) ___lambda13__gtk_button_clicked, self, 0);
#line 190 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp3_ = self->priv->restore_button;
#line 190 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_signal_connect_object (_tmp3_, "clicked", (GCallback) ___lambda14__gtk_button_clicked, self, 0);
#line 194 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp4_ = self->priv->confirm_button;
#line 194 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_signal_connect_object (_tmp4_, "clicked", (GCallback) ___lambda15__gtk_button_clicked, self, 0);
#line 208 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp5_ = self->priv->go_back_button;
#line 208 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_signal_connect_object (_tmp5_, "clicked", (GCallback) ___lambda18__gtk_button_clicked, self, 0);
#line 214 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp6_ = self->priv->file_box;
#line 214 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_signal_connect_object (_tmp6_, "row-activated", (GCallback) ___lambda19__gtk_list_box_row_activated, self, 0);
#line 1262 "TrashStoreWidget.c"
}

static void
trash_applet_widgets_trash_store_widget_set_buttons_sensitive (TrashAppletWidgetsTrashStoreWidget* self,
                                                               gboolean is_sensitive)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
#line 220 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_if_fail (self != NULL);
#line 221 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp0_ = self->priv->restore_button;
#line 221 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, is_sensitive);
#line 222 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp1_ = self->priv->delete_button;
#line 222 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, is_sensitive);
#line 1281 "TrashStoreWidget.c"
}

static void
trash_applet_widgets_trash_store_widget_show_confirmation (TrashAppletWidgetsTrashStoreWidget* self,
                                                           gboolean restore)
{
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
	GtkRevealer* _tmp8_;
#line 225 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_if_fail (self != NULL);
#line 226 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->restoring = restore;
#line 228 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	if (restore) {
#line 1297 "TrashStoreWidget.c"
		GtkLabel* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 229 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp0_ = self->priv->revealer_text;
#line 229 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp1_ = g_strdup_printf ("<b>%s</b>", _ ("Really restore all items?"));
#line 229 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp2_ = _tmp1_;
#line 229 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		gtk_label_set_markup (_tmp0_, _tmp2_);
#line 229 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_g_free0 (_tmp2_);
#line 1311 "TrashStoreWidget.c"
	} else {
		GtkLabel* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 231 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp3_ = self->priv->revealer_text;
#line 231 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp4_ = g_strdup_printf ("<b>%s</b>", _ ("Really delete all items?"));
#line 231 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp5_ = _tmp4_;
#line 231 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		gtk_label_set_markup (_tmp3_, _tmp5_);
#line 231 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_g_free0 (_tmp5_);
#line 1326 "TrashStoreWidget.c"
	}
#line 234 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp6_ = self->priv->restore_button;
#line 234 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, FALSE);
#line 235 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp7_ = self->priv->delete_button;
#line 235 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, FALSE);
#line 236 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp8_ = self->priv->revealer;
#line 236 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	gtk_revealer_set_reveal_child (_tmp8_, TRUE);
#line 1340 "TrashStoreWidget.c"
}

/**
         * sort_by_name will determine the order that two given rows should be in 
         * using pure alphabetical order.
         * 
         * @param row1 The first row to use for comparison
         * @param row2 The second row to use for comparison
         * @return < 0 if row1 should be before row2, 0 if they are equal and > 0 otherwise
         */
static gint
trash_applet_widgets_trash_store_widget_sort_by_name (TrashAppletWidgetsTrashStoreWidget* self,
                                                      GtkListBoxRow* row1,
                                                      GtkListBoxRow* row2)
{
	TrashAppletWidgetsTrashItem* trash_item_1 = NULL;
	GtkWidget* _tmp0_;
	TrashAppletWidgetsTrashItem* _tmp1_;
	TrashAppletWidgetsTrashItem* trash_item_2 = NULL;
	GtkWidget* _tmp2_;
	TrashAppletWidgetsTrashItem* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint result;
#line 247 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 247 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_val_if_fail (row1 != NULL, 0);
#line 247 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_val_if_fail (row2 != NULL, 0);
#line 248 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) row1);
#line 248 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp1_ = _g_object_ref0 (TRASH_APPLET_WIDGETS_IS_TRASH_ITEM (_tmp0_) ? ((TrashAppletWidgetsTrashItem*) _tmp0_) : NULL);
#line 248 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_item_1 = _tmp1_;
#line 249 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp2_ = gtk_bin_get_child ((GtkBin*) row2);
#line 249 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp3_ = _g_object_ref0 (TRASH_APPLET_WIDGETS_IS_TRASH_ITEM (_tmp2_) ? ((TrashAppletWidgetsTrashItem*) _tmp2_) : NULL);
#line 249 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_item_2 = _tmp3_;
#line 251 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp4_ = trash_applet_widgets_trash_item_get_file_name (trash_item_1);
#line 251 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp5_ = _tmp4_;
#line 251 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp6_ = trash_applet_widgets_trash_item_get_file_name (trash_item_2);
#line 251 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp7_ = _tmp6_;
#line 251 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	result = g_utf8_collate (_tmp5_, _tmp7_);
#line 251 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (trash_item_2);
#line 251 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (trash_item_1);
#line 251 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	return result;
#line 1401 "TrashStoreWidget.c"
}

/**
         * sort_by_name_reverse will determine the order that two given rows should be in 
         * using reverse alphabetical order.
         * 
         * @param row1 The first row to use for comparison
         * @param row2 The second row to use for comparison
         * @return < 0 if row1 should be before row2, 0 if they are equal and > 0 otherwise
         */
static gint
trash_applet_widgets_trash_store_widget_sort_by_name_reverse (TrashAppletWidgetsTrashStoreWidget* self,
                                                              GtkListBoxRow* row1,
                                                              GtkListBoxRow* row2)
{
	TrashAppletWidgetsTrashItem* trash_item_1 = NULL;
	GtkWidget* _tmp0_;
	TrashAppletWidgetsTrashItem* _tmp1_;
	TrashAppletWidgetsTrashItem* trash_item_2 = NULL;
	GtkWidget* _tmp2_;
	TrashAppletWidgetsTrashItem* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint result;
#line 262 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 262 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_val_if_fail (row1 != NULL, 0);
#line 262 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_val_if_fail (row2 != NULL, 0);
#line 263 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) row1);
#line 263 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp1_ = _g_object_ref0 (TRASH_APPLET_WIDGETS_IS_TRASH_ITEM (_tmp0_) ? ((TrashAppletWidgetsTrashItem*) _tmp0_) : NULL);
#line 263 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_item_1 = _tmp1_;
#line 264 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp2_ = gtk_bin_get_child ((GtkBin*) row2);
#line 264 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp3_ = _g_object_ref0 (TRASH_APPLET_WIDGETS_IS_TRASH_ITEM (_tmp2_) ? ((TrashAppletWidgetsTrashItem*) _tmp2_) : NULL);
#line 264 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_item_2 = _tmp3_;
#line 266 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp4_ = trash_applet_widgets_trash_item_get_file_name (trash_item_2);
#line 266 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp5_ = _tmp4_;
#line 266 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp6_ = trash_applet_widgets_trash_item_get_file_name (trash_item_1);
#line 266 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp7_ = _tmp6_;
#line 266 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	result = g_utf8_collate (_tmp5_, _tmp7_);
#line 266 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (trash_item_2);
#line 266 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (trash_item_1);
#line 266 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	return result;
#line 1462 "TrashStoreWidget.c"
}

/**
         * sort_by_type will determine the order that two given rows should be in.
         * 
         * Directories should be above files, and both types should be sorted alphabetically.
         * 
         * @param row1 The first row to use for comparison
         * @param row2 The second row to use for comparison
         * @return < 0 if row1 should be before row2, 0 if they are equal and > 0 otherwise
         */
static gint
trash_applet_widgets_trash_store_widget_sort_by_type (TrashAppletWidgetsTrashStoreWidget* self,
                                                      GtkListBoxRow* row1,
                                                      GtkListBoxRow* row2)
{
	TrashAppletWidgetsTrashItem* trash_item_1 = NULL;
	GtkWidget* _tmp0_;
	TrashAppletWidgetsTrashItem* _tmp1_;
	TrashAppletWidgetsTrashItem* trash_item_2 = NULL;
	GtkWidget* _tmp2_;
	TrashAppletWidgetsTrashItem* _tmp3_;
	gboolean _tmp4_ = FALSE;
	TrashAppletWidgetsTrashItem* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	gint result;
#line 278 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 278 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_val_if_fail (row1 != NULL, 0);
#line 278 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_val_if_fail (row2 != NULL, 0);
#line 279 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) row1);
#line 279 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp1_ = _g_object_ref0 (TRASH_APPLET_WIDGETS_IS_TRASH_ITEM (_tmp0_) ? ((TrashAppletWidgetsTrashItem*) _tmp0_) : NULL);
#line 279 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_item_1 = _tmp1_;
#line 280 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp2_ = gtk_bin_get_child ((GtkBin*) row2);
#line 280 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp3_ = _g_object_ref0 (TRASH_APPLET_WIDGETS_IS_TRASH_ITEM (_tmp2_) ? ((TrashAppletWidgetsTrashItem*) _tmp2_) : NULL);
#line 280 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_item_2 = _tmp3_;
#line 282 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp5_ = trash_item_1;
#line 282 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp6_ = trash_applet_widgets_trash_item_get_is_directory (_tmp5_);
#line 282 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp7_ = _tmp6_;
#line 282 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	if (_tmp7_) {
#line 1516 "TrashStoreWidget.c"
		TrashAppletWidgetsTrashItem* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 282 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp8_ = trash_item_2;
#line 282 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp9_ = trash_applet_widgets_trash_item_get_is_directory (_tmp8_);
#line 282 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp10_ = _tmp9_;
#line 282 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp4_ = _tmp10_;
#line 1528 "TrashStoreWidget.c"
	} else {
#line 282 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp4_ = FALSE;
#line 1532 "TrashStoreWidget.c"
	}
#line 282 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	if (_tmp4_) {
#line 1536 "TrashStoreWidget.c"
		TrashAppletWidgetsTrashItem* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		TrashAppletWidgetsTrashItem* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
#line 283 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp11_ = trash_item_1;
#line 283 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp12_ = trash_applet_widgets_trash_item_get_file_name (_tmp11_);
#line 283 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp13_ = _tmp12_;
#line 283 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp14_ = trash_item_2;
#line 283 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp15_ = trash_applet_widgets_trash_item_get_file_name (_tmp14_);
#line 283 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp16_ = _tmp15_;
#line 283 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		result = g_utf8_collate (_tmp13_, _tmp16_);
#line 283 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_g_object_unref0 (trash_item_2);
#line 283 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_g_object_unref0 (trash_item_1);
#line 283 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		return result;
#line 1563 "TrashStoreWidget.c"
	} else {
		gboolean _tmp17_ = FALSE;
		TrashAppletWidgetsTrashItem* _tmp18_;
		gboolean _tmp19_;
		gboolean _tmp20_;
#line 284 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp18_ = trash_item_1;
#line 284 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp19_ = trash_applet_widgets_trash_item_get_is_directory (_tmp18_);
#line 284 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		_tmp20_ = _tmp19_;
#line 284 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		if (_tmp20_) {
#line 1577 "TrashStoreWidget.c"
			TrashAppletWidgetsTrashItem* _tmp21_;
			gboolean _tmp22_;
			gboolean _tmp23_;
#line 284 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			_tmp21_ = trash_item_2;
#line 284 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			_tmp22_ = trash_applet_widgets_trash_item_get_is_directory (_tmp21_);
#line 284 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			_tmp23_ = _tmp22_;
#line 284 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			_tmp17_ = !_tmp23_;
#line 1589 "TrashStoreWidget.c"
		} else {
#line 284 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			_tmp17_ = FALSE;
#line 1593 "TrashStoreWidget.c"
		}
#line 284 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
		if (_tmp17_) {
#line 285 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			result = -1;
#line 285 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			_g_object_unref0 (trash_item_2);
#line 285 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			_g_object_unref0 (trash_item_1);
#line 285 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			return result;
#line 1605 "TrashStoreWidget.c"
		} else {
			gboolean _tmp24_ = FALSE;
			TrashAppletWidgetsTrashItem* _tmp25_;
			gboolean _tmp26_;
			gboolean _tmp27_;
#line 286 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			_tmp25_ = trash_item_1;
#line 286 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			_tmp26_ = trash_applet_widgets_trash_item_get_is_directory (_tmp25_);
#line 286 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			_tmp27_ = _tmp26_;
#line 286 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			if (!_tmp27_) {
#line 1619 "TrashStoreWidget.c"
				TrashAppletWidgetsTrashItem* _tmp28_;
				gboolean _tmp29_;
				gboolean _tmp30_;
#line 286 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
				_tmp28_ = trash_item_2;
#line 286 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
				_tmp29_ = trash_applet_widgets_trash_item_get_is_directory (_tmp28_);
#line 286 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
				_tmp30_ = _tmp29_;
#line 286 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
				_tmp24_ = _tmp30_;
#line 1631 "TrashStoreWidget.c"
			} else {
#line 286 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
				_tmp24_ = FALSE;
#line 1635 "TrashStoreWidget.c"
			}
#line 286 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
			if (_tmp24_) {
#line 287 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
				result = 1;
#line 287 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
				_g_object_unref0 (trash_item_2);
#line 287 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
				_g_object_unref0 (trash_item_1);
#line 287 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
				return result;
#line 1647 "TrashStoreWidget.c"
			} else {
				TrashAppletWidgetsTrashItem* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				TrashAppletWidgetsTrashItem* _tmp34_;
				const gchar* _tmp35_;
				const gchar* _tmp36_;
#line 289 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
				_tmp31_ = trash_item_1;
#line 289 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
				_tmp32_ = trash_applet_widgets_trash_item_get_file_name (_tmp31_);
#line 289 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
				_tmp33_ = _tmp32_;
#line 289 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
				_tmp34_ = trash_item_2;
#line 289 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
				_tmp35_ = trash_applet_widgets_trash_item_get_file_name (_tmp34_);
#line 289 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
				_tmp36_ = _tmp35_;
#line 289 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
				result = g_utf8_collate (_tmp33_, _tmp36_);
#line 289 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
				_g_object_unref0 (trash_item_2);
#line 289 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
				_g_object_unref0 (trash_item_1);
#line 289 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
				return result;
#line 1675 "TrashStoreWidget.c"
			}
		}
	}
}

static gint
trash_applet_widgets_trash_store_widget_sort_by_newest (TrashAppletWidgetsTrashStoreWidget* self,
                                                        GtkListBoxRow* row1,
                                                        GtkListBoxRow* row2)
{
	TrashAppletWidgetsTrashItem* trash_item_1 = NULL;
	GtkWidget* _tmp0_;
	TrashAppletWidgetsTrashItem* _tmp1_;
	TrashAppletWidgetsTrashItem* trash_item_2 = NULL;
	GtkWidget* _tmp2_;
	TrashAppletWidgetsTrashItem* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
	gint result;
#line 293 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 293 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_val_if_fail (row1 != NULL, 0);
#line 293 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_val_if_fail (row2 != NULL, 0);
#line 294 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) row1);
#line 294 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp1_ = _g_object_ref0 (TRASH_APPLET_WIDGETS_IS_TRASH_ITEM (_tmp0_) ? ((TrashAppletWidgetsTrashItem*) _tmp0_) : NULL);
#line 294 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_item_1 = _tmp1_;
#line 295 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp2_ = gtk_bin_get_child ((GtkBin*) row2);
#line 295 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp3_ = _g_object_ref0 (TRASH_APPLET_WIDGETS_IS_TRASH_ITEM (_tmp2_) ? ((TrashAppletWidgetsTrashItem*) _tmp2_) : NULL);
#line 295 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_item_2 = _tmp3_;
#line 297 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp4_ = trash_applet_widgets_trash_item_get_deletion_time (trash_item_2);
#line 297 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp5_ = _tmp4_;
#line 297 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp6_ = trash_applet_widgets_trash_item_get_deletion_time (trash_item_1);
#line 297 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp7_ = _tmp6_;
#line 297 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	result = g_date_time_compare (_tmp5_, _tmp7_);
#line 297 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (trash_item_2);
#line 297 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (trash_item_1);
#line 297 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	return result;
#line 1731 "TrashStoreWidget.c"
}

static gint
trash_applet_widgets_trash_store_widget_sort_by_oldest (TrashAppletWidgetsTrashStoreWidget* self,
                                                        GtkListBoxRow* row1,
                                                        GtkListBoxRow* row2)
{
	TrashAppletWidgetsTrashItem* trash_item_1 = NULL;
	GtkWidget* _tmp0_;
	TrashAppletWidgetsTrashItem* _tmp1_;
	TrashAppletWidgetsTrashItem* trash_item_2 = NULL;
	GtkWidget* _tmp2_;
	TrashAppletWidgetsTrashItem* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
	gint result;
#line 300 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 300 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_val_if_fail (row1 != NULL, 0);
#line 300 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_return_val_if_fail (row2 != NULL, 0);
#line 301 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) row1);
#line 301 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp1_ = _g_object_ref0 (TRASH_APPLET_WIDGETS_IS_TRASH_ITEM (_tmp0_) ? ((TrashAppletWidgetsTrashItem*) _tmp0_) : NULL);
#line 301 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_item_1 = _tmp1_;
#line 302 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp2_ = gtk_bin_get_child ((GtkBin*) row2);
#line 302 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp3_ = _g_object_ref0 (TRASH_APPLET_WIDGETS_IS_TRASH_ITEM (_tmp2_) ? ((TrashAppletWidgetsTrashItem*) _tmp2_) : NULL);
#line 302 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_item_2 = _tmp3_;
#line 304 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp4_ = trash_applet_widgets_trash_item_get_deletion_time (trash_item_1);
#line 304 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp5_ = _tmp4_;
#line 304 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp6_ = trash_applet_widgets_trash_item_get_deletion_time (trash_item_2);
#line 304 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_tmp7_ = _tmp6_;
#line 304 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	result = g_date_time_compare (_tmp5_, _tmp7_);
#line 304 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (trash_item_2);
#line 304 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (trash_item_1);
#line 304 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	return result;
#line 1784 "TrashStoreWidget.c"
}

static void
trash_applet_widgets_trash_store_widget_class_init (TrashAppletWidgetsTrashStoreWidgetClass * klass,
                                                    gpointer klass_data)
{
#line 23 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	trash_applet_widgets_trash_store_widget_parent_class = g_type_class_peek_parent (klass);
#line 23 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	g_type_class_adjust_private_offset (klass, &TrashAppletWidgetsTrashStoreWidget_private_offset);
#line 23 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	G_OBJECT_CLASS (klass)->finalize = trash_applet_widgets_trash_store_widget_finalize;
#line 1797 "TrashStoreWidget.c"
}

static void
trash_applet_widgets_trash_store_widget_instance_init (TrashAppletWidgetsTrashStoreWidget * self,
                                                       gpointer klass)
{
#line 23 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv = trash_applet_widgets_trash_store_widget_get_instance_private (self);
#line 27 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->restoring = FALSE;
#line 30 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->store_header = NULL;
#line 31 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->drive_icon = NULL;
#line 32 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->store_label = NULL;
#line 33 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->restore_button = NULL;
#line 34 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->delete_button = NULL;
#line 36 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->revealer = NULL;
#line 37 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->revealer_container = NULL;
#line 38 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->revealer_text = NULL;
#line 39 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->revealer_buttons = NULL;
#line 40 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->go_back_button = NULL;
#line 41 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->confirm_button = NULL;
#line 43 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self->priv->file_box = NULL;
#line 1832 "TrashStoreWidget.c"
}

static void
trash_applet_widgets_trash_store_widget_finalize (GObject * obj)
{
	TrashAppletWidgetsTrashStoreWidget * self;
#line 23 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TRASH_APPLET_WIDGETS_TYPE_TRASH_STORE_WIDGET, TrashAppletWidgetsTrashStoreWidget);
#line 25 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_trash_applet_trash_store_unref0 (self->priv->trash_store);
#line 26 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_hash_table_unref0 (self->priv->trash_items);
#line 30 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->store_header);
#line 31 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->drive_icon);
#line 32 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->store_label);
#line 33 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->restore_button);
#line 34 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->delete_button);
#line 36 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->revealer);
#line 37 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->revealer_container);
#line 38 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->revealer_text);
#line 39 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->revealer_buttons);
#line 40 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->go_back_button);
#line 41 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->confirm_button);
#line 43 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	_g_object_unref0 (self->priv->file_box);
#line 23 "../budgie-trash/trash/src/Widgets/TrashStoreWidget.vala"
	G_OBJECT_CLASS (trash_applet_widgets_trash_store_widget_parent_class)->finalize (obj);
#line 1871 "TrashStoreWidget.c"
}

GType
trash_applet_widgets_trash_store_widget_get_type (void)
{
	return trash_applet_widgets_trash_store_widget_type_id;
}

GType
trash_applet_widgets_trash_store_widget_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (TrashAppletWidgetsTrashStoreWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) trash_applet_widgets_trash_store_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TrashAppletWidgetsTrashStoreWidget), 0, (GInstanceInitFunc) trash_applet_widgets_trash_store_widget_instance_init, NULL };
	trash_applet_widgets_trash_store_widget_type_id = g_type_module_register_type (module, gtk_box_get_type (), "TrashAppletWidgetsTrashStoreWidget", &g_define_type_info, 0);
	TrashAppletWidgetsTrashStoreWidget_private_offset = sizeof (TrashAppletWidgetsTrashStoreWidgetPrivate);
	return trash_applet_widgets_trash_store_widget_type_id;
}

